unit BMGMaxMap;
interface
uses windows,kol,BMaxGTypes, BMGSpriteGenerator,KolPng;

type TMaxmapData=record
  header:Theader;
  mapsize:Tmapsize;
  minimap:Tminimap;
  map,map2:Tmap;
  mapitemscount:word;
 bitmaps:array of Tbitmaps;
  Mpalette,Palette2:TDPalette;
  passtab:array of byte;
end;
type PMask=^TMask;
   TMask=object(TObj)
   p:array of array of byte;
   procedure load(m:Pmask;rct:trect);overload;
   procedure load(fill:byte;rct:trect);overload;
   destructor destroy;virtual;
end;
type PMaxMap=^TMaxMap;
   TMaxMap=object(TObj)

   Data:TMaxMapData;
   tmpdata:array of array of byte;
   tmpdataInt:array of integer;
   rtable,fwtable,btable:array of byte;
   loaded:boolean;
   PalOK:boolean;
   MapFilename:string;
   minimap:PBitmap;

   map:Tmap;
   mapsize:TmapSizeEx;
   procedure loadMaxFile(dir,name:string);
   procedure saveMaxFile(dir,name:string);
   procedure SaveMinimapToStream(Stream:Pstream);
   procedure SaveMapBitmapToFile(Fname:String;divby:byte=1);
   procedure SaveMapPNGToFile(Fname:String;divby:byte=1);
   procedure SaveAllSpritesToStream(cols:integer;Stream:Pstream;gridwidth:byte=0);
   procedure SaveOneSpriteToStream(num:integer;Stream:PStream);
   procedure SaveToFile(Dat:Theader;Fname:string);overload;
   procedure SaveToFile(Dat:Tminimap;Fname:string);overload;
   procedure SaveToFile(Dat:PBitmap;Fname:string);overload;
   procedure savePNGtofile(Dat:PBitmap;Fname:string);overload;
   procedure SaveToFile(Dat:Tmap;Fname:string);overload;
   procedure SaveToStream(Dat:Tmap;WhereTo:Pstream);overload;
   procedure SaveToFile(What:string;Fname:string);overload;
   procedure SaveToFile(What:string;colcount:integer;Fname:string);overload;
   procedure SaveToFile(x:string;y:string;mapfile:string;sprbmpfile:string;passfile:string;minimapbmpfile:string;fname:string);overload;
   procedure getspritetogenerator(num:integer);
   procedure getMapColorStatisticToListView(LV:Pcontrol);
   function getmaxpass(x,y:integer):byte;
   function getspritebitmap(num:integer):PBitmap;

   function getpalette(whattype:byte=0):TDPalette;
   function getALLspritesbitmap(col:integer;gridwidth:byte=0):PBitmap;
   function getMinimapBitmap:Pbitmap;
   function getMapBitmap(divby:byte=1;mask:PMask=nil;percto:Pcontrol=nil):Pbitmap;
   function addMapItem(spr:TBitmaps):integer;

   destructor destroy;virtual;
   procedure GenerateRedAndFWBitmaps;
   Function GenerateRedAndFWPalette:boolean;
   procedure calccolorstatistic(bypasstab:byte=10;min:word=65535;max:word=65535);
   private
   procedure SaveMapBitmapToStream(Stream:Pstream;divby:byte=1;m:PMask=nil;l:word=0;t:word=0;w:word=0;h:word=0;percto:Pcontrol=nil);
   procedure GetNearColors(maxdifference:single=0.1);
   procedure clearpalitre;
end;
function NewMaxMap(Withgenerator:boolean=false):PMaxMap;
function NewMask(w,h:integer):PMask;
implementation
  {$WARN UNSAFE_TYPE OFF} 
  {$WARN UNSAFE_CODE OFF}
function NewMask(W,H:integer):PMask;
var f1,f2:integer;
begin
{$IFDEF BMGLOG}
log('function NewMask(W='+int2str(w)+',H='+int2str(h)+':integer):PMask;');
{$ENDIF}
   new(result,create);
   setlength(result.p,w,h);
   for f1:=0 to w-1 do for f2:=0 to h-1 do result.p[f1,f2]:=0;
end;
function NewMaxMap(Withgenerator:boolean=false):PMaxMap;
begin
{$IFDEF BMGLOG}
log('function NewMaxMap(Withgenerator:boolean):PMaxMap;');
{$ENDIF}
   new(result,create);
   if high(Glsr)<(GlsrSize-1) then setlength(Glsr,GlsrSize);
   Glsr[IDMaxmap]:=result;
   result.tmpdata:=nil;
   result.PalOK:=false;

   result.Data.mapitemscount:=0;
   if Withgenerator then generator:=TSprGenerator.create;
end;

destructor TMaxMap.destroy;
begin
{$IFDEF BMGLOG}
log('destructor TMaxMap.destroy;');
{$ENDIF}
setlength(rtable,0);
setlength(fwtable,0);
setlength(btable,0);
  setlength(tmpdataInt,0);
  tmpdataInt:=nil;
  setlength(data.bitmaps,0);
  setlength(data.passtab,0);
  setlength(Mapfilename,0);
  if minimap<>nil then begin
     minimap.Free;
     minimap:=nil;
  end;

  inherited;
end;

function TMaxMap.getMinimapBitmap: Pbitmap;
var stream:Pstream;
begin
{$IFDEF BMGLOG}
log('function TMaxMap.getMinimapBitmap: Pbitmap;');
{$ENDIF}
if minimap=nil then begin
minimap:=NewDibBitmap(112,112,pf8bit);

stream:=NewMemoryStream;

SaveMinimapToStream(stream);
stream.Position:=0;
minimap.LoadFromStream(stream);

stream.Free;
end;
result:=minimap;
end;

procedure TMaxMap.loadMaxFile(dir,name: string);
var f:PStream;
var i1:integer;
var f1,f2,f3,f4:byte;
var p:TMpalette;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.loadMaxFile(dir='''+dir+''',name='''+name+''': string);');
{$ENDIF}
PalOK:=false;
loaded:=false;
Mapfilename:=name;
if not(FileExists(dir+name)) then exit;
if minimap<>nil then begin minimap.Free;end;minimap:=nil;
f:=NewReadFileStream(dir+name);

f.Read(data.header,5);

f.Read(data.mapsize,4);
mapsize.arr:=data.mapsize;

f.read(data.minimap,12544);

f.read(data.map,25088);
for f1:=0 to 111 do 
   for f2:=0 to 111 do map[f1,f2]:=data.map[f2,f1];

f.read(f3,1);f.read(f4,1);data.mapitemscount:=f3+f4*256;
setlength(data.bitmaps,data.mapitemscount);
for i1:=0 to data.mapitemscount-1 do
   f.read(data.bitmaps[i1].data,4096);
   f.read(P,768);
for i1:=0 to 255 do begin

   data.Mpalette[i1].color:=0;
   data.Mpalette[i1].rgb.rgbRed:=p[i1,1];
   data.Mpalette[i1].rgb.rgbGreen:=p[i1,2];
   data.Mpalette[i1].rgb.rgbBlue:=p[i1,3];
end;
if generator<>nil then generator.mpalette:=data.Mpalette;
setlength(data.passtab,data.mapitemscount);
for i1:=0 to data.mapitemscount-1 do begin
   f.read(data.passtab[i1],1);
   data.bitmaps[i1].pass:=data.passtab[i1];
   data.bitmaps[i1].kind:=0;
end;

f.Free;
loaded:=true;
end;

procedure TMaxMap.SaveMinimapToStream(Stream: Pstream);
var  bh:bmHeader;
var f1,f2:byte;
var m2:Tminimap;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveMinimapToStream(Stream: Pstream);');
{$ENDIF}
for f1:=0 to 111 do
   for f2:=0 to 111 do
     m2[f2,f1]:=data.minimap[111-f2,f1];
stream.Position:=0;

bh.f.Typf:=ord('B')+(ord('M')*256);
bh.f.Res1:=0;
bh.f.Res2:=0;
bh.f.OfBm:=1078;
bh.i.Size:=40;
bh.i.Plan:=1;
bh.i.BitC:=8;
bh.i.Comp:=0;
bh.f.Size:=(112*112)+1078;
bh.i.Widt:=112;
bh.i.Heig:=112;
bh.i.SizI:=112*112;
bh.i.XppM:=0;
bh.i.YppM:=0;
bh.i.NCoL:=256;
bh.i.NCoI:=256;
bh.p:=data.Mpalette;

stream.Write(bh.f.Typf,2);
stream.Write(bh.f.Size,4);
stream.Write(bh.f.Res1,2);
stream.Write(bh.f.Res2,2);
stream.Write(bh.f.OfBm,4);
stream.Write(bh.i.Size,4);
stream.Write(bh.i.Widt,4);
stream.Write(bh.i.Heig,4);
stream.Write(bh.i.Plan,2);
stream.Write(bh.i.BitC,2);
stream.Write(bh.i.Comp,4);
stream.Write(bh.i.SizI,4);
stream.Write(bh.i.XppM,4);
stream.Write(bh.i.YppM,4);
stream.Write(bh.i.NCoL,4);
stream.Write(bh.i.NCoI,4);
stream.Write(bh.p,1024);
stream.Write(m2,112*112);

end;

procedure TMaxMap.SaveToFile(Dat: Theader; Fname: string);
var f:Pstream;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(Dat: Theader; Fname='''+fname+''': string);');
{$ENDIF}
f:=NewWriteFileStream(Fname);
f.Write(dat,sizeof(dat));
f.Write(data.mapsize,sizeof(data.mapsize));
f.Free;
end;

procedure TMaxMap.SaveToFile(Dat: Tminimap; Fname: string);
var f:Pstream;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(Dat: Tminimap; Fname='''+fname+''': string);');
{$ENDIF}
f:=NewWriteFileStream(Fname);
f.Write(dat,sizeof(dat));
f.Free;
end;

procedure TMaxMap.SaveToFile(Dat: PBitmap; Fname: string);
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(Dat: PBitmap; Fname='''+fname+''': string);');
{$ENDIF}
Dat.SaveToFile(Fname);
end;

procedure TMaxMap.SaveToFile(Dat: Tmap; Fname: string);
var f:Pstream;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(Dat: Tmap; Fname: string);');
{$ENDIF}
f:=NewWriteFileStream(Fname);
f.Write(dat,sizeof(dat));
f.Free;
end;

procedure TMaxMap.SaveToFile(What, Fname: string);
var f:Pstream;
var f1:integer;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(What='''+what+''', Fname='''+fname+''': string);');
{$ENDIF}
if what = 'passtable' then begin
  f:=NewWriteFileStream(Fname);
  for f1:= 0 to Data.mapitemscount-1 do
    f.Write(data.passtab[f1],1);
  f.free;
end;

if what = 'spritesDAT' then begin
  f:=NewWriteFileStream(Fname);
for f1:=0 to data.mapitemscount-1 do
   f.write(data.bitmaps[f1],4096);
  f.free;
end;

end;

procedure TMaxMap.SaveAllSpritesToStream(cols:integer;Stream: Pstream;gridwidth:byte=0);
var  bh:bmHeader;
var i2:byte;
var h:integer;
var f1,f2,f3,f4,f5,f6:integer;
var ln:array[0..63]of byte;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveAllSpritesToStream(cols:integer='+int2str(cols)+';Stream: Pstream;gridwidth:byte='+int2str(gridwidth)+');');
{$ENDIF}

h:=(trunc(int(data.mapitemscount / cols)));

if (h*cols)<=(data.mapitemscount+1) then inc(h);
stream.Position:=0;

bh.f.Typf:=ord('B')+(ord('M')*256);
bh.f.Res1:=0;
bh.f.Res2:=0;
bh.f.OfBm:=1078;
bh.i.Size:=40;
bh.i.Plan:=1;
bh.i.BitC:=8;
bh.i.Comp:=0;
bh.f.Size:=(cols*(h*(64+gridwidth)))+1078;
bh.i.Widt:=cols*(64+gridwidth);
bh.i.Heig:=h*(64+gridwidth);
bh.i.SizI:=(cols*(h*(64+gridwidth)));
bh.i.XppM:=0;
bh.i.YppM:=0;
bh.i.NCoL:=256;
bh.i.NCoI:=256;
bh.p:=data.Mpalette;

stream.Write(bh.f.Typf,2);
stream.Write(bh.f.Size,4);
stream.Write(bh.f.Res1,2);
stream.Write(bh.f.Res2,2);
stream.Write(bh.f.OfBm,4);
stream.Write(bh.i.Size,4);
stream.Write(bh.i.Widt,4);
stream.Write(bh.i.Heig,4);
stream.Write(bh.i.Plan,2);
stream.Write(bh.i.BitC,2);
stream.Write(bh.i.Comp,4);
stream.Write(bh.i.SizI,4);
stream.Write(bh.i.XppM,4);
stream.Write(bh.i.YppM,4);
stream.Write(bh.i.NCoL,4);
stream.Write(bh.i.NCoI,4);
stream.Write(bh.p,1024);
i2:=0;
if (cols*(64+gridwidth))<>((trunc((cols*(64+gridwidth))/4))*4) then begin
   f6:=((trunc((cols*(64+gridwidth))/4)+1)*4)-(cols*(64+gridwidth));
end else f6:=0;
for f2:=h-1 downto 0 do begin
 for f3:=63 downto 0 do begin
  for f1:=0 to cols-1 do begin
    f5:=(f2*cols)+f1;
    if f5<data.mapitemscount then begin
       for f4:=0 to 63 do begin
         ln[f4]:=data.bitmaps[f5].data[f3,f4];
       end;
    end else begin
       for f4:=0 to 63 do ln[f4]:=i2;
    end;
    stream.Write(ln,64);
    for f5:=1 to gridwidth do stream.Write(i2,1);
  end;
    for f5:=1 to f6 do stream.Write(i2,1);
 end;
 for f1:=1 to gridwidth do begin
    for f5:=1 to (cols*(64+gridwidth))+f6 do stream.Write(i2,1);
 end;
end;
end;

procedure TMaxMap.SaveToFile(What: string; colcount: integer; Fname: string);
var stream:Pstream;

var f1,f2:integer;
var b:PBitmap;
var p:PPngObject;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(What: string='''+what+'''; colcount: integer='+int2str(colcount)+'; Fname: string='''+fname+''');');
{$ENDIF}
if loaded then begin
if what='spritesPNG' then begin
   stream:=NewMemoryStream;
   SaveAllSpritesToStream(colcount,stream);
   stream.Position:=0;
   b:=NewBitmap(1,1);
   b.LoadFromStream(stream);

   stream.Free;
   p:=NewPngObject;
   p.AssignHandle(b.Handle,false,0);
   p.SaveToFile(Fname);
   p.Free;
   b.Free;
end;

if what='spritesBMP' then begin
   stream:=NewMemoryStream;
   SaveAllSpritesToStream(colcount,stream);
   stream.SaveToFile(fname,0,stream.Position);
   stream.Free;
end;
if what='spritesPNG1' then begin
   stream:=NewMemoryStream;
   SaveAllSpritesToStream(colcount,stream,1);
   stream.Position:=0;
   b:=NewBitmap(1,1);
   b.LoadFromStream(stream);

   stream.Free;
   p:=NewPngObject;
   p.AssignHandle(b.Handle,false,0);
   p.SaveToFile(Fname);
   p.Free;
   b.Free;
end;

if what='spritesBMP1' then begin
   stream:=NewMemoryStream;
   SaveAllSpritesToStream(colcount,stream,1);
   stream.SaveToFile(fname,0,stream.Position);
   stream.Free;
end;
if what='oneSpritePCX' then begin
   stream:=NewMemoryStream;
 generator.saveSpriteToStreamAsPCX(stream,2);
   stream.SaveToFile(fname,0,stream.Position);
   stream.Free;
end;

if what='oneSprite' then begin
   stream:=NewMemoryStream;
 SaveOneSpriteToStream(colcount,stream);
   stream.SaveToFile(fname,0,stream.Position);
   stream.Free;
end;
if what='PassGrid' then begin
   stream:=NewMemoryStream;
      for f2:=0 to mapsize.y-1 do begin
   for f1:=0 to mapsize.x-1 do begin
          stream.WriteStr(int2str(getmaxpass(f1,f2))+int2str(getmaxpass(f1,f2)));
   end;
     stream.WriteStr(#13#10)
      end;

   stream.SaveToFile(fname,0,stream.Position);
   stream.Free;

end;
end;
end;

procedure TMaxMap.SaveToFile(x, y, mapfile, sprbmpfile, passfile,minimapbmpfile,fname: string);
var  ss:string;
var f:Pstream;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToFile(x, y, mapfile, sprbmpfile, passfile,minimapbmpfile,fname: string);');
{$ENDIF}
  f:=NewWriteFileStream(Fname);
  ss:='x='+x;
  f.Write(ss,length(ss));
  ss:='y='+y;
  f.Write(ss,length(ss));
  ss:='='+mapfile;
  f.Write(ss,length(ss));
  ss:='='+sprbmpfile;
  f.Write(ss,length(ss));
  ss:='='+passfile;
  f.Write(ss,length(ss));
  ss:='='+minimapbmpfile;
  f.Write(ss,length(ss));

  f.free;

end;

procedure TMaxMap.SaveOneSpriteToStream(num: integer; Stream: PStream);
var  bh:bmHeader;
var i1,i2:byte;
var ln:array[0..63]of byte;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveOneSpriteToStream(num: integer='+int2str(num)+'; Stream: PStream);');
{$ENDIF}
if num>data.mapitemscount then exit;
stream.Position:=0;
bh.f.Typf:=ord('B')+(ord('M')*256);
bh.f.Res1:=0;
bh.f.Res2:=0;
bh.f.OfBm:=1078;
bh.i.Size:=40;
bh.i.Plan:=1;
bh.i.BitC:=8;
bh.i.Comp:=0;
bh.f.Size:=(64*64)+1078;
bh.i.Widt:=64;
bh.i.Heig:=64;
bh.i.SizI:=64*64;
bh.i.XppM:=0;
bh.i.YppM:=0;
bh.i.NCoL:=256;
bh.i.NCoI:=256;
bh.p:=data.Mpalette;

stream.Write(bh.f.Typf,2);
stream.Write(bh.f.Size,4);
stream.Write(bh.f.Res1,2);
stream.Write(bh.f.Res2,2);
stream.Write(bh.f.OfBm,4);
stream.Write(bh.i.Size,4);
stream.Write(bh.i.Widt,4);
stream.Write(bh.i.Heig,4);
stream.Write(bh.i.Plan,2);
stream.Write(bh.i.BitC,2);
stream.Write(bh.i.Comp,4);
stream.Write(bh.i.SizI,4);
stream.Write(bh.i.XppM,4);
stream.Write(bh.i.YppM,4);
stream.Write(bh.i.NCoL,4);
stream.Write(bh.i.NCoI,4);
stream.Write(bh.p,1024);
if num>=0 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=data.bitmaps[num].data[63-i1,i2];
   stream.Write(ln,64);
end;
end;
if num=-1 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=generator.tmpout.data[63-i1,i2];
   stream.Write(ln,64);
end;
end;
if num=-2 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=generator.temp.data[63-i1,i2];
   stream.Write(ln,64);
end;
end;

end;

function TMaxMap.getspritebitmap(num:integer): PBitmap;
var stream:Pstream;
begin
{$IFDEF BMGLOG}
log('function TMaxMap.getspritebitmap(num:integer='+int2str(num)+'): PBitmap;');
{$ENDIF}
result:=nil;
if loaded then begin
result:=NewBitmap(64,64);
stream:=NewMemoryStream;
SaveOneSpriteToStream(num,stream);
stream.Position:=0;
result.LoadFromStream(stream);

stream.Free;
end;
end;

function TMaxMap.getALLspritesbitmap(col: integer; gridwidth: byte): PBitmap;
var stream:Pstream;
begin
{$IFDEF BMGLOG}
log('function TMaxMap.getALLspritesbitmap(col: integer='+int2str(col)+'; gridwidth: byte='+int2str(gridwidth)+'): PBitmap;');
{$ENDIF}
result:=nil;
if loaded then begin
   result:=NewDibBitmap(1,1,pf8bit);
   stream:=NewMemoryStream;
   SaveAllSpritesToStream(col,stream,gridwidth);
   stream.Position:=0;
   result.LoadFromStream(stream);
   stream.Free;
end;
end;

procedure TMaxMap.getspritetogenerator(num: integer);
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.getspritetogenerator(num: integer='+int2str(num)+');');
{$ENDIF}
if num<0 then exit;
if num>data.mapitemscount then exit;
generator.mpalette:=data.Mpalette;
generator.load(data.bitmaps[num]);
end;

procedure TMaxMap.SaveToStream(Dat: Tmap; WhereTo: Pstream);
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveToStream(Dat: Tmap; WhereTo: Pstream);');
{$ENDIF}
if Whereto=nil then exit;
WhereTo.Write(dat,sizeof(dat));
end;

procedure TMaxMap.SaveMapBitmapToFile(Fname: String; divby: byte);
var f:Pstream;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveMapBitmapToFile(Fname: String='''+fname+'''; divby: byte='+int2str(divby)+');');
{$ENDIF}
f:=NewMemoryStream;
SaveMapBitmapToStream(f,divby);
f.savetofile(Fname,0,f.Position);
f.Free;
end;

procedure TMaxMap.getMapColorStatisticToListView(LV: Pcontrol);
var f1,f2:integer;
var ss:string;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.getMapColorStatisticToListView(LV: Pcontrol);');
{$ENDIF}
calccolorstatistic;
if high(tmpdataint)<0 then exit;
LV.Clear;

while lv.LVColCount<8 do lv.LVColAdd('',taLeft,50);
lv.LVColWidth[0]:=100;
lv.LVColWidth[7]:=300;
f2:=0;
for f1:=0 to 255 do if tmpdataint[f1]>0 then inc(f2);
lv.LVItemAdd('    ');
lv.LVItems[0,1]:=int2str(f2);
lv.LVColText[1]:='';lv.LVColText[2]:='';lv.LVColText[3]:='';lv.LVColText[4]:='';lv.LVColText[5]:='';
LV.LVItemAdd('');
for f1:=0 to 255 do begin
   lv.LVItemAdd(' '+int2str(f1));
   lv.LVItems[f1+2,1]:=int2str(tmpdataint[f1]);
end;
calccolorstatistic(1);f2:=0;
for f1:=0 to 255 do begin
   lv.LVItems[f1+2,2]:=int2str(tmpdataint[f1]);
   if tmpdataint[f1]>0 then inc(f2);
end;
LV.LVItems[0,2]:=int2str(f2);
calccolorstatistic(2);f2:=0;
for f1:=0 to 255 do begin
   lv.LVItems[f1+2,3]:=int2str(tmpdataint[f1]);
   if tmpdataint[f1]>0 then inc(f2);
end;
LV.LVItems[0,3]:=int2str(f2);
calccolorstatistic(0);f2:=0;
for f1:=0 to 255 do begin
   lv.LVItems[f1+2,4]:=int2str(tmpdataint[f1]);
   if tmpdataint[f1]>0 then inc(f2);
end;
LV.LVItems[0,4]:=int2str(f2);
calccolorstatistic(3);f2:=0;
for f1:=0 to 255 do begin
   lv.LVItems[f1+2,5]:=int2str(tmpdataint[f1]);
   if tmpdataint[f1]>0 then inc(f2);
end;
LV.LVItems[0,5]:=int2str(f2);
GetNearColors;
f2:=0;
for f1:=0 to 255 do begin
   lv.LVItems[f1+2,6]:=int2str(tmpdataint[f1])+'('+int2str(data.mpalette[f1].rgb.rgbBlue)+','+int2str(data.mpalette[f1].rgb.rgbGreen)+','+int2str(data.mpalette[f1].rgb.rgbRed)+')';
   if tmpdataint[f1]>0 then inc(f2);
end;
LV.LVItems[0,6]:=int2str(f2);
for f1:=0 to 255 do begin
   ss:='';
   for f2:=0 to 255 do begin
      if tmpdata[f1,f2]<>0 then ss:=ss+int2str(tmpdata[f1,f2])+'|';
   end;
   lv.LVItems[f1+2,7]:=int2str(f1)+'='+ss;
end;

setlength(tmpdata,0,0);
setlength(tmpdataint,0);
end;

procedure TMaxMap.calccolorstatistic(bypasstab:byte;min:word;max:word);
var f1,f2,f3,mn,mx:integer;
begin
{$IFDEF BMGLOG}
log('TMaxMap.calccolorstatistic(bypasstab:byte='+int2str(bypasstab)+';min:word='+int2str(min)+';max:word='+int2str(max)+');');
if loaded then log('calccolorstatistic->loaded=true')else log('calccolorstatistic->loaded=false');
{$ENDIF}

if loaded=false then exit;
if min<65535 then mn:=min else mn:=0;
if max<65535 then mx:=max else mx:=high(data.bitmaps);
if high(tmpdataInt)<>255 then setlength(tmpdataInt,256);
for f1:=0 to 255 do tmpdataInt[f1]:=0;
{$IFDEF BMGLOG}
log('calccolorstatistic->. : min='+int2str(mn)+', max='+int2str(mx));
{$ENDIF}
for f1:=mn to mx do
begin
   for f2:=0 to 63 do
    for f3:=0 to 63 do
      if bypasstab=10 then begin
          inc(tmpdataInt[data.bitmaps[f1].data[f2,f3]])
      end else begin
        if bypasstab=data.passtab[f1] then
           inc(tmpdataInt[data.bitmaps[f1].data[f2,f3]])
      end;
end;
{$IFDEF BMGLOG}
log('END calccolorstatistic');
{$ENDIF}
end;

procedure TMaxMap.GetNearColors(maxdifference:single);
var f1,f2,pc:integer;
var r,g,b,r1,g1,b1:byte;
function nearcolor(c1,c2:byte;match:single):boolean;
var rr:single;
var mn,mx:byte;
begin
   rr:=match+1;
   if c1>c2 then begin mn:=c2;mx:=c1;end else begin mn:=c1;mx:=c2;end;
   if (mn<>0) and (mx<>0) then rr:=1-(mn / mx);
   if (mn=0) and (mx=0) then rr:=0;
   if (mn=0) and (mx<>0) then rr:=(mx / 255);
   if rr<=match then result:=true else result:=false;
end;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.GetNearColors(maxdifference:single='+double2str(maxdifference)+');');
{$ENDIF}
if not(loaded) then exit;
{$IFDEF BMGLOG}
log('GetNearColors->clearpalitre');
{$ENDIF}
clearpalitre;
{$IFDEF BMGLOG}
log('GetNearColors->setlength');
{$ENDIF}
setlength(tmpdata,256,256);
setlength(tmpdataint,256);
for f1:=0 to 255 do begin
   tmpdataint[f1]:=0;
   for f2:=0 to 255 do tmpdata[f1,f2]:=0;
end;
{$IFDEF BMGLOG}
log('GetNearColors->search');
{$ENDIF}
for f1:=0 to 255 do begin
   pc:=0;
   r:=data.Mpalette[f1].rgb.rgbRed;
   g:=data.Mpalette[f1].rgb.rgbGreen;
   b:=data.Mpalette[f1].rgb.rgbBlue;
   if not((r=0)and(g=0)and(b=0)) then begin
      for f2:=0 to 255 do
      if f2<>f1 then begin
         r1:=data.Mpalette[f2].rgb.rgbRed;
         g1:=data.Mpalette[f2].rgb.rgbGreen;
         b1:=data.Mpalette[f2].rgb.rgbBlue;
         if nearcolor(r,r1,maxdifference) and
            nearcolor(g,g1,maxdifference) and
            nearcolor(b,b1,maxdifference) then begin
               inc(tmpdataint[f1]);
               tmpdata[f1,pc]:=f2;
               inc(pc);
            end;
      end;
   end;
end;
{$IFDEF BMGLOG}
log('End GetNearColors');
{$ENDIF}
end;

procedure TMaxMap.clearpalitre;
var f1:integer;
begin
{$IFDEF BMGLOG}
log('TMaxMap.clearpalitre',5);
log('clearpalitre->calccolorstatistic');
{$ENDIF}
calccolorstatistic;
{$IFDEF BMGLOG}
log('clearpalitre->  tmpdataint');
{$ENDIF}
if high(tmpdataint)<>255 then exit;
{$IFDEF BMGLOG}
log('clearpalitre-> ');
{$ENDIF}
for f1:=0 to 255 do begin
   if tmpdataint[f1]=0 then begin
      data.Mpalette[f1].color:=0;
   end;
end;
{$IFDEF BMGLOG}
log('End Clearpalitre',-5);
{$ENDIF}

end;

function TMaxMap.getpalette(whattype:byte=0): TDPalette;
var i1:integer;
var r,g,b:byte;
begin
{$IFDEF BMGLOG}
log('TMaxMap.getpalette(whattype:byte='+int2str(whattype)+')');
{$ENDIF}

if not(loaded) then exit;
if whattype=0 then begin
  for i1:=0 to 255 do begin        
     result[i1].color:=data.mpalette[i1].color;

  end;
end;
if whattype=1 then begin
  for i1:=0 to 255 do begin        
     r:=data.Mpalette[i1].rgb.rgbRed;
     g:=data.Mpalette[i1].rgb.rgbGreen;
     b:=data.Mpalette[i1].rgb.rgbBlue;

     if (r<=g)and(g<=b)then begin r:=trunc((r+b+b+b)/4);g:=trunc((g+b+b+b)/4);end;
     if (r<=b)and(b<=g)then begin r:=trunc((r+g+g+g)/4);b:=trunc((b+g+g+g)/4);end;

     if (b<=g)and(g<=r)then begin b:=trunc((b+r+r+r)/4);g:=trunc((g+r+r+r)/4);end;
     if (b<=r)and(r<=g)then begin b:=trunc((b+g+g+g)/4);r:=trunc((r+g+g+g)/4);end;

     if (g<=r)and(r<=b)then begin g:=trunc((g+b+b+b)/4);r:=trunc((r+b+b+b)/4);end;
     if (g<=b)and(b<=r)then begin g:=trunc((g+r+r+r)/4);b:=trunc((b+r+r+r)/4);end;

     result[i1].rgb.rgbRed:=trunc(r / 1.3);
     result[i1].rgb.rgbGreen:=trunc(g / 1.3);
     result[i1].rgb.rgbBlue:=trunc(b / 1.3);
  end;
end;
if whattype=2 then begin
  for i1:=0 to 255 do begin        
     result[i1].rgb.rgbBlue:=trunc(data.Mpalette[i1].rgb.rgbBlue/ 2);
     result[i1].rgb.rgbGreen:=trunc(data.Mpalette[i1].rgb.rgbGreen  / 2);
     result[i1].rgb.rgbRed:=trunc(data.Mpalette[i1].rgb.rgbRed); 
  end;
end;
if whattype=3 then begin 
  for i1:=0 to 255 do begin        
     result[i1].rgb.rgbBlue:=trunc(data.Mpalette[i1].rgb.rgbBlue);
     result[i1].rgb.rgbGreen:=trunc(data.Mpalette[i1].rgb.rgbGreen  / 2);
     result[i1].rgb.rgbRed:=trunc(data.Mpalette[i1].rgb.rgbRed / 2); 
     if result[i1].rgb.rgbBlue<(result[i1].rgb.rgbGreen+result[i1].rgb.rgbRed) then result[i1].rgb.rgbBlue:=(result[i1].rgb.rgbGreen+result[i1].rgb.rgbRed);
  end;
end;

end;

function TMaxMap.GenerateRedAndFWPalette: boolean;
var frcl,ucl:byte;
var f1,f2:integer;
var cs:single;
var tmp:TDpalette;
label rep;
begin
result:=false;
if PalOK then begin
{$IFDEF BMGLOG}
log('NOTSTARTED function TMaxMap.GenerateRedAndFWPalette: boolean;');
{$ENDIF}
   result:=true;
   exit;
end;
{$IFDEF BMGLOG}
log('function TMaxMap.GenerateRedAndFWPalette: boolean;',2);
{$ENDIF}
PalOK:=true;
cs:=0.1;
rep:;
GetNearColors(cs);
calccolorstatistic;
setlength(rtable,256);
setlength(fwtable,256);
setlength(btable,256);
{$IFDEF BMGLOG}
log('    ?');
{$ENDIF}

frcl:=255;
for f1:=0 to 255 do begin
   if tmpdataint[f1]>0 then dec(frcl);
   tmpdata[f1,255]:=0;
   rtable[f1]:=0;
   fwtable[f1]:=0;
end;

frcl:=frcl div 3;
{$IFDEF BMGLOG}
log('Freecolors='+int2str(frcl));
{$ENDIF}
if frcl<10 then begin
   showmessage('   ?       ?    .  ,  ');
   exit;
end;
{$IFDEF BMGLOG}
log('     ');
{$ENDIF}

for f1:=0 to 255 do
   if (tmpdataint[f1]>0) then begin
      if tmpdata[f1,255]=0 then begin
         tmpdata[f1,255]:=f1;
         for f2:=0 to 254 do begin
            if (tmpdata[f1,f2]>0) then
              if tmpdata[tmpdata[f1,f2],255]=0 then
                 tmpdata[tmpdata[f1,f2],255]:=f1;
         end;
      end;
   end;
{$IFDEF BMGLOG}
log('c   ');
{$ENDIF}

ucl:=0;
for f1:=0 to 255 do
   if (tmpdataint[f1]>0) and (tmpdata[f1,255]=f1) then inc(ucl);
if ucl>frcl then begin
   cs:=cs+0.05;goto rep;
end;
for f1:=0 to 255 do data.Palette2[f1]:=data.Mpalette[f1];
{$IFDEF BMGLOG}
log('  #1 FW');
{$ENDIF}

tmp:=getpalette(1);
for f1:=0 to 255 do
   if tmpdataint[f1]>0 then
      if tmpdata[f1,255]=f1 then begin
        ucl:=0;
        for f2:=255 downto 0 do if data.Palette2[f2].color=0 then ucl:=f2;
        fwtable[f1]:=ucl;
        data.Palette2[ucl]:=tmp[f1];
      end else begin
        fwtable[f1]:=fwtable[tmpdata[f1,255]];
      end;
{$IFDEF BMGLOG}
log('  #2 R');
{$ENDIF}
tmp:=getpalette(2);
for f1:=0 to 255 do
   if tmpdataint[f1]>0 then
      if tmpdata[f1,255]=f1 then begin
        ucl:=0;
        for f2:=255 downto 0 do if data.Palette2[f2].color=0 then ucl:=f2;
        rtable[f1]:=ucl;
        data.Palette2[ucl]:=tmp[f1];
      end else begin
        rtable[f1]:=rtable[tmpdata[f1,255]];
      end;
{$IFDEF BMGLOG}
log('  #3 B');
{$ENDIF}
tmp:=getpalette(3);
for f1:=0 to 255 do
   if tmpdataint[f1]>0 then
      if tmpdata[f1,255]=f1 then begin
        ucl:=0;
        for f2:=255 downto 0 do if data.Palette2[f2].color=0 then ucl:=f2;
        btable[f1]:=ucl;
        data.Palette2[ucl]:=tmp[f1];
      end else begin
        btable[f1]:=btable[tmpdata[f1,255]];
      end;
{$IFDEF BMGLOG}
log('');
{$ENDIF}
setlength(tmpdata,0,0);
setlength(tmpdataint,0);
result:=true;
{$IFDEF BMGLOG}
log('END GenerateRedAndFWPalette',-2);
{$ENDIF}
end;

procedure TMaxMap.GenerateRedAndFWBitmaps;
var cs,f1:word;
var i1,i2:byte;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.GenerateRedAndFWBitmaps;');
{$ENDIF}
if GenerateRedAndFWPalette=false then exit;
data.mapitemscount:=data.mapitemscount*3;
setlength(data.bitmaps,data.mapitemscount);
cs:=data.mapitemscount;
for f1:=0 to data.mapitemscount-1 do begin
   data.bitmaps[f1+cs].kind:=1;
   data.bitmaps[f1+cs].pass:=data.bitmaps[f1].pass;
   for i1:=0 to 63 do for i2:=0 to 63 do
      data.bitmaps[f1+cs].data[i1,i2]:=fwtable[data.bitmaps[f1].data[i1,i2]];
end;
cs:=data.mapitemscount*2;
for f1:=0 to data.mapitemscount-1 do begin
   data.bitmaps[f1+cs].kind:=1;
   data.bitmaps[f1+cs].pass:=data.bitmaps[f1].pass;
   for i1:=0 to 63 do for i2:=0 to 63 do
      data.bitmaps[f1+cs].data[i1,i2]:=rtable[data.bitmaps[f1].data[i1,i2]];
end;

end;

function TMaxMap.getMapBitmap(divby: byte;mask:PMask;percto:Pcontrol): Pbitmap;
var stream:Pstream;
begin
{$IFDEF BMGLOG}
log('function TMaxMap.getMapBitmap(divby: byte='+int2str(divby)+';mask:PMask): Pbitmap;');
{$ENDIF}
result:=nil;
if loaded then begin
   result:=NewDIBBitmap(1,1,pf8bit);
   stream:=NewMemoryStream;
   SaveMapBitmapToStream(stream,divby,mask,0,0,0,0,percto);
   stream.Position:=0;
   result.LoadFromStream(stream);
   stream.Free;
end;
end;

procedure TMaxMap.SaveMapBitmapToStream(Stream:Pstream;divby:byte;m:PMask;l,t,w,h:word;percto:Pcontrol);
var mapsz:TmapSizeEx;
var f1,f2,f3,f4,f5,f6,f7,cs:integer; 
var bh:bmHeader;
var bsz:byte;
var csh:array [0..249]of byte;
var cshpz:byte;
var ss:string;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveMapBitmapToStream(Stream:Pstream;divby:byte='+int2str(divby)+';m:PMask);');
{$ENDIF}   
if divby<=0 then divby:=1;
if divby>=64 then divby:=64;
if not(loaded) then exit;
if m<>nil then begin
   if self.GenerateRedAndFWPalette=false then exit;
end;
mapsz.arr:=data.mapsize;
bsz:=64 div divby;
f5:=divby div 2;
if data.mapitemscount<=0 then exit;
if w=0 then w:=mapsz.x;
if h=0 then h:=mapsz.y;

setlength(tmpdata,(w*bsz),(h*bsz));
for f1:=0 to w-1 do begin
  for f2:=0 to h-1 do begin
     f7:=map[f1+l,f2+t].idword;
     if m<>nil then cs:=m.p[f1+l,f2+t] else cs:=0;
     if cs=0 then
     for f3:=0 to bsz-1  do begin f6:=(f3*divby)+f5;
      for f4:=0 to bsz-1 do begin
         tmpdata[(f1*bsz)+f3,(f2*bsz)+f4]:=data.bitmaps[f7].data[(f4*divby)+f5,f6];
      end;end;
     if cs=1 then
     for f3:=0 to bsz-1  do begin f6:=(f3*divby)+f5;
      for f4:=0 to bsz-1 do
         tmpdata[(f1*bsz)+f3,(f2*bsz)+f4]:=fwtable[data.bitmaps[f7].data[(f4*divby)+f5,f6]];
      end;
     if cs=2 then
     for f3:=0 to bsz-1  do begin f6:=(f3*divby)+f5;
      for f4:=0 to bsz-1 do
         tmpdata[(f1*bsz)+f3,(f2*bsz)+f4]:=rtable[data.bitmaps[f7].data[(f4*divby)+f5,f6]];
      end;
     if cs=3 then
     for f3:=0 to bsz-1  do begin f6:=(f3*divby)+f5;
      for f4:=0 to bsz-1 do
         tmpdata[(f1*bsz)+f3,(f2*bsz)+f4]:=btable[data.bitmaps[f7].data[(f4*divby)+f5,f6]];
      end;
  end;

end;
stream.Position:=0;
bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;

bh.f.Size:=((w*bsz)*(h*bsz))+1078;
bh.i.Widt:=w*bsz;bh.i.Heig:=h*bsz;
bh.i.SizI:=((w*bsz)*(h*bsz));
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
if m<>nil then bh.p:=data.Palette2 else bh.p:=data.Mpalette;

stream.Write(bh.f.Typf,2);stream.Write(bh.f.Size,4);stream.Write(bh.f.Res1,2);stream.Write(bh.f.Res2,2);stream.Write(bh.f.OfBm,4);
stream.Write(bh.i.Size,4);stream.Write(bh.i.Widt,4);stream.Write(bh.i.Heig,4);stream.Write(bh.i.Plan,2);stream.Write(bh.i.BitC,2);stream.Write(bh.i.Comp,4);stream.Write(bh.i.SizI,4);stream.Write(bh.i.XppM,4);stream.Write(bh.i.YppM,4);stream.Write(bh.i.NCoL,4);stream.Write(bh.i.NCoI,4);
stream.Write(bh.p,1024);
cshpz:=0;
for f2:=(h*bsz)-1 downto 0 do begin
   for f1:=0 to (w*bsz)-1 do begin
      csh[cshpz]:=tmpdata[f1,f2];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         stream.write(csh,250);

      end;

   end;
end;

if cshpz>0 then stream.write(csh,cshpz+1);
setlength(tmpdata,0,0);
tmpdata:=nil;
if percto<>nil then begin percto.Caption:=ss;end;

end;

function TMaxMap.getmaxpass(x, y: integer): byte;
begin
   result:=3;
   if not(loaded) then exit;
   result:=data.passtab[map[x,y].idword]
end;

procedure TMaxMap.saveMaxFile(dir, name: string);
var f:Pstream;
var f3,f4:byte;
var i1:integer;
var p:TMpalette;
begin
{$IFDEF BMGLOG}log('procedure TMaxMap.saveMaxFile(dir='''+dir+''',name='''+name+''': string);');{$ENDIF}
   f:=NewMemoryStream;
   data.header[1]:=ORD('W');
   data.header[2]:=ORD('R');
   data.header[3]:=ORD('X');
   data.header[4]:=1;
   data.header[5]:=0;
f.Write(data.header,5);
f.Write(data.mapsize,4);
f.Write(data.minimap,12544);
f.Write(data.map,25088);
f4:=data.mapitemscount div 256;
f3:=data.mapitemscount-(f4*256);
f.Write(f3,1);f.Write(f4,1);
for i1:=0 to data.mapitemscount-1 do
   f.Write(data.bitmaps[i1].data,4096);
for i1:=0 to 255 do begin
   p[i1,1]:=data.Mpalette[i1].rgb.rgbRed;
   p[i1,2]:=data.Mpalette[i1].rgb.rgbGreen;
   p[i1,3]:=data.Mpalette[i1].rgb.rgbBlue;
end;
f.Write(P,768);
setlength(data.passtab,data.mapitemscount);
for i1:=0 to data.mapitemscount-1 do begin
   f.Write(data.passtab[i1],1);
end;

   f.SaveToFile(dir+name+'.wrl',0,f.Position);
   f.free;
end;

function TMaxMap.addMapItem(spr: TBitmaps): integer;
begin
setlength(data.bitmaps,data.mapitemscount+1);
data.bitmaps[data.mapitemscount]:=spr;
setlength(data.passtab,data.mapitemscount+1);
data.passtab[data.mapitemscount]:=spr.pass;
inc(data.mapitemscount);
result:=data.mapitemscount-1;
end;

procedure TMaxMap.SaveMapPNGToFile(Fname: String; divby: byte);
var f:Pstream;
var p:PPngObject;
var b:Pbitmap;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SaveMapPNGToFile(Fname: String='''+fname+'''; divby: byte='+int2str(divby)+');');
{$ENDIF}
f:=NewMemoryStream;
SaveMapBitmapToStream(f,divby);
f.Position:=0;
b:=NewBitmap(1,1);
b.LoadFromStream(f);

f.Free;
p:=NewPngObject;
p.AssignHandle(b.Handle,false,0);
p.SaveToFile(Fname);
p.Free;
b.Free;
end;

procedure TMaxMap.savePNGtofile(Dat: PBitmap; Fname: string);
var p:PPngObject;
begin
{$IFDEF BMGLOG}
log('procedure TMaxMap.SavePNGToFile(Dat: PBitmap; Fname='''+fname+''': string);');
{$ENDIF}
p:=NewPngObject;
p.AssignHandle(dat.Handle,false,0);
p.SaveToFile(Fname);
p.Free;
end;

destructor TMask.destroy;
begin
{$IFDEF BMGLOG}log('destructor TMask.destroy;');{$ENDIF}
setlength(p,0,0);
inherited;
end;

procedure TMask.load(m: Pmask;rct:trect);
var f1,f2:integer;
begin
{$IFDEF BMGLOG}log('procedure TMask.load(m: Pmask;rct:trect=('+int2str(rct.left)+','+int2str(rct.top)+','+int2str(rct.right)+','+int2str(rct.bottom)+'));');{$ENDIF}
for f1:=rct.Left to rct.Right do
 for f2:=rct.Top to rct.Bottom do
  p[f1,f2]:=m.p[f1,f2];
end;

procedure TMask.load(fill: byte; rct: trect);
var f1,f2:integer;
begin
{$IFDEF BMGLOG}
log('procedure TMask.load(fill: byte='+int2str(fill)+';rct:trect=('+int2str(rct.left)+','+int2str(rct.top)+','+int2str(rct.right)+','+int2str(rct.bottom)+'));');
{$ENDIF}
for f1:=rct.Left to rct.Right do
 for f2:=rct.Top to rct.Bottom do
  p[f1,f2]:=fill;
end;

end.

