unit BMGSpriteGenerator;

interface
uses KOL,BMaxGTypes,BMGSpriteCollection;
const l0cmin=4;
const l0cmax=7;
const l0max=11;//l0 = 12x12 1=4 1c=16x16pix
const l2cmin=8;
const l2cmax=15;
const l2max=23;//l2 = 24x24 1=8 1c=8x8pix
const l3cmin=16;
const l3cmax=31;
const l3max=47;//l3 = 48x48 1=16 1c=4x4pix
const l4cmin=32;
const l4cmax=63;
const l4max=95;//l4 = 96x96 1=32 1c=2x2pix
const l5cmin=64;
const l5cmax=127;
const l5max=191;//l4 = 192x192 1=64 1c=1pix

type tgenIN=array [0..15,0..15]of byte;//4x4 1=16
type tgenIN2=array [0..31,0..31]of byte;//4x4 1=16

type tgenl0=array [0..l0max,0..l0max]of byte;//4x4 1=16
type tgenl2=array [0..l2max,0..l2max]of byte;//8x8 1=8
//type tgenl3=array [0..l3max,0..l3max]of byte;//16x16 1=4
type tgenmask=record
   mskin:tgenIN;
   mskin2:tgenIN2;
   l0:tgenl0;
   l1:array [0..l0max,0..l0max]of byte;//4x4 1=16
   l2:tgenl2;
   l3:array [0..l3max,0..l3max]of byte;//16x16 1=4
   l4:array [0..l4max,0..l4max]of byte;//32x32 1=2
   l5:array [0..l5max,0..l5max]of byte;//64x64 1=1
   sFinal:Tbitmaps;

end;
type
  TRGBPixel = packed record
    R, G, B: Byte;
  end;

type TPCXHeader = record
    Manufacturer      : Byte; //  10 = ZSoft .PCX
    Version           : Byte; //0 =  2.5
                              //2 =  2.8    
                              //3 =  2.8    
                              //5 =  3.0
    Encoding          : Byte; //1 = .PCX   
    BitsPerPixel      : Byte; //     
    Xmin              : Word; //  (Xmin, Ymin) - (Xmax, Ymax)   
    Ymin              : Word;
    Xmax              : Word;
    Ymax              : Word;
    Hres              : Word; //   
    Vres              : Word; //   
    ColorMap          : array[ 0..15 ] of TRGBPixel;
    Reserved          : Byte;
    NPlanes           : Byte; //  
    BytesPerLine      : Word; //      
                              //( PCX-    )
    PaletteInfo       : Byte; //  :
                              //1 = /-,
                              //2 =  
    Filler            : array[ 0..58 ] of Byte; // 
  end;

type TSprGenerator=class
   water,beach,land:array of Tbitmaps;
   wcount,bcount,lcount:integer;
   sbh:bmHeader;
   temp,tmpout:Tbitmaps;
   genmask:tgenmask;
   pass,sprok:byte;
   loaded:boolean;
   colorID,colorQTY:array of word;
   colorcount:integer;
   mpalette:TDPalette;
   sprdata:array of array of byte;
   sprw,sprh:integer;
   lastposx,lastposy:integer;
   constructor create;
   destructor destroy;override;
   procedure load(maxbmp:Tbitmaps);overload;
   procedure load(srcb:TSRCBitmap);overload;
   procedure load(filename:string);overload;
   procedure saveSpriteToStreamAsPCX(strm:PStream;inout:byte=1);
   procedure saveSpriteToStream(strm:PStream;inout:byte=1);
   procedure saveSprToStream(strm:PStream);
   procedure saveAnimatedWaterSpriteToStreamAsPCX(strm:PStream;inout:byte=1;hqanim:boolean=true);
   function getgeneratorbitmap(num:smallint=1):Pbitmap;
   function getSprbitmap:Pbitmap;
   procedure getSprColors(whereto:PControl);
   procedure setSprColors(from:PControl);
   procedure changeColor(id:byte;mode: byte=0;ColpalID:byte=0);
   procedure GenerateSpriteWithNumber(num:integer;color:byte;background:byte);
   procedure GenerateSpriteWithALLCol;
   procedure GenerateTechnoDemoMapForSprite(id:integer;percTo:Pcontrol=nil);
   procedure drawMask(Pbox:Pcontrol;level:byte=0);
   procedure generatesprite(tolevel:byte=7;fromlevel:byte=0);
   procedure randomizespr;
   procedure removecolors(fromBmp:TBitmaps;toId:byte=0);overload;
   procedure removecolors(fromBmp:TSRCBitmap;toId:byte=0);overload;
   procedure generatespriteEX;
   procedure calcsprcolors(where:byte=0);
   function generateSprPalette(mp:TDPalette):boolean;
   procedure makesprite(posx,posy:integer);
   private
   function nearcolor(c1,c2:byte;match:single):boolean;

end;
var Generator,Generator2:TSprGenerator;
implementation
uses BMGMaxMap,MapGeneratorMain,BMaxGMapGenerator;
{ TSprGenerator }

procedure TSprGenerator.calcsprcolors(where:byte);
var f2,f3,f4,f6,f5:integer;
var c:byte;
var ok:boolean;
begin
     setlength(colorID,0);
     setlength(colorQTY,0);
     colorcount:=-1;
if where=0 then begin
     for f2:=0 to 63 do
      for f3:=0 to 63 do begin
         f6:=-1;
         c:=temp.data[f2,f3];
         for f5:=0 to colorcount do begin
            if colorID[f5]=c then begin f6:=f5;colorQTY[f5]:=colorQTY[f5]+1;end;
         end;
         if f6=-1 then begin
           inc(colorcount);
           setlength(colorID,colorcount+1);setlength(colorQTY,colorcount+1);
                     colorID[colorcount]:=c;         colorQTY[colorcount]:=1;
         end;
      end;
end;
if where=1 then begin
     for f2:=0 to sprw-1 do
      for f3:=0 to sprh-1 do begin
         f6:=-1;
         c:=sprdata[f2,f3];
         for f5:=0 to colorcount do begin
            if colorID[f5]=c then begin f6:=f5;colorQTY[f5]:=colorQTY[f5]+1;end;
         end;
         if f6=-1 then begin
           inc(colorcount);
           setlength(colorID,colorcount+1);setlength(colorQTY,colorcount+1);
                     colorID[colorcount]:=c;         colorQTY[colorcount]:=1;
         end;
      end;
end;
      // 
      colorcount:=high(colorID);
      repeat
      ok:=true;
      for f2:=0 to colorcount-1 do begin
         if colorID[f2]>colorID[f2+1] then begin
            f4:=colorID[f2];colorId[f2]:=colorId[f2+1];colorId[f2+1]:=f4;
            f4:=colorQTY[f2];colorQTY[f2]:=colorQTY[f2+1];colorQTY[f2+1]:=f4;
            ok:=false;
         end;
      end;
      until ok;
end;

procedure TSprGenerator.changeColor(id: byte; mode: byte;
  ColpalID: byte);
var f1,f2:integer;
var c:byte;
begin
if mode=0 then c:=colorID[id] else c:=id;
//if id<0 then exit;
for f1:=0 to 63 do
 for f2:=0 to 63 do
  if temp.data[f1,f2]=c then temp.data[f1,f2]:=ColpalID;
end;

constructor TSprGenerator.create;
var f1,f2:integer;
begin
sprok:=0;
   setlength(sprdata,0,0);
   sprw:=0;sprh:=0;
for f1:=0 to l0max do for f2:=0 to l0max do genmask.l0[f1,f2]:=1;
loaded:=false;
colorID:=nil;colorQTY:=nil;
water:=nil;wcount:=-1;
beach:=nil;bcount:=-1;
land:=nil;lcount:=-1;
end;

destructor TSprGenerator.destroy;
begin
   setlength(sprdata,0,0);
   sprw:=0;sprh:=0;
   loaded:=false;
   setlength(colorID,0);colorID:=nil;
   setlength(colorQTY,0);colorQTY:=nil;
   setlength(water,0);water:=nil;wcount:=-1;
   setlength(beach,0);beach:=nil;bcount:=-1;
   setlength(land,0);land:=nil;lcount:=-1;
  inherited;
end;

procedure TSprGenerator.drawMask(Pbox: Pcontrol;level:byte);
var f1,f2,w,h,cmn,cmx:integer;
procedure col(colr:byte);begin
        Pbox.Canvas.Brush.Color:=clYellow;
        if colr=0 then Pbox.Canvas.Brush.Color:=clGreen;
        if colr=1 then Pbox.Canvas.Brush.Color:=clAqua;
        if colr=2 then Pbox.Canvas.Brush.Color:=clMaroon;
        if colr=3 then Pbox.Canvas.Brush.Color:=clBlue;
       //    if colr=4 then Pbox.Canvas.Brush.Color:=$10101010;
//           if colr=5 then Pbox.Canvas.Brush.Color:=$20202020;
//           if colr=6 then Pbox.Canvas.Brush.Color:=$30303030;
//           if colr=7 then Pbox.Canvas.Brush.Color:=$40404040;
//           if colr=8 then Pbox.Canvas.Brush.Color:=$50505050;

end;
begin
Pbox.Canvas.Brush.Color:=clAqua;
PBox.Canvas.FillRect(PBox.canvas.ClipRect);
Pbox.Canvas.Pen.Color:=clBlack;
//0- 1- 2- 3-
begin w:=l0max;h:=l0max;cmn:=l0cmin;cmx:=l0cmax;end;
if level=1 then begin w:=l0max;h:=l0max;cmn:=l0cmin;cmx:=l0cmax;end;
if level=2 then begin w:=l2max;h:=l2max;cmn:=l2cmin;cmx:=l2cmax;end;
if level=3 then begin w:=l3max;h:=l3max;cmn:=l3cmin;cmx:=l3cmax;end;
if level=4 then begin w:=l4max;h:=l4max;cmn:=l4cmin;cmx:=l4cmax;end;
if level=5 then begin w:=l5max;h:=l5max;cmn:=l5cmin;cmx:=l5cmax;end;
if level<>0 then begin w:=cmx-cmn;h:=cmx-cmn;end;
inc(cmx);
for f1:=0 to (w) do
   for f2:=0 to (h) do begin
     if level=0 then col(genmask.l0[f1,f2]);
     if level=1 then col(genmask.l1[f1+cmn,f2+cmn]);
     if level=2 then col(genmask.l2[f1+cmn,f2+cmn]);
     if level=3 then col(genmask.l3[f1+cmn,f2+cmn]);
     if level=4 then col(genmask.l4[f1+cmn,f2+cmn]);
     if level=5 then col(genmask.l5[f1+cmn,f2+cmn]);
     Pbox.Canvas.FillRect(makerect(trunc(f1*PBox.Width/(w+1)),trunc(f2*PBox.Height/(h+1)),trunc((f1+1)*PBox.Width/(w+1)),trunc((f2+1)*PBox.Height/(h+1))));
   end;
if (level<>5)and(level<4) then
for f1:=0 to (w) do begin
Pbox.Canvas.Pen.Color:=clBlack;
   if (f1=cmn) or (f1=cmx) then Pbox.Canvas.Pen.Color:=clBlue;
   PBox.Canvas.MoveTo(0,trunc(f1*(PBox.Height-1)/(w+1)));
   Pbox.Canvas.LineTo(PBox.Width,trunc(f1*(PBox.Height-1)/(h+1)));
   PBox.Canvas.MoveTo(trunc(f1*(PBox.Width-1)/(w+1)),0);
   PBox.Canvas.LineTo(trunc(f1*(PBox.Width-1)/(h+1)),PBox.Height);
end;

end;

procedure TSprGenerator.generatesprite(tolevel:byte;fromlevel:byte);
var i,j,w,l:integer;//  ,b
var bout:Tbitmaps;
var bsprites:TBMGSpriteCollection;
function l1change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
begin
   result:=false;
   for i:=1 to l0max-1 do for j:=1 to l0max-1 do
     if genmask.l1[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
//         if ((i+k-1)>=0)and((i+k-1)<=l0max)and((j+l-1)>=0)and((j+l-1)<=l0max)then
            if genmask.l1[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then genmask.l1[i,j]:=p4;
   end;
end;
function l2change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l2max-1 do for j:=1 to l2max-1 do
     if genmask.l2[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if genmask.l2[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then tm.l2[i,j]:=p4;
   end;
   genmask:=tm;
end;
function l3change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l3max-1 do for j:=1 to l3max-1 do
     if genmask.l3[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if genmask.l3[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then tm.l3[i,j]:=p4;
   end;
   genmask:=tm;
end;
function l4change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l4max-1 do for j:=1 to l4max-1 do
     if genmask.l4[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if genmask.l4[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then tm.l4[i,j]:=p4;
   end;
   genmask:=tm;
end;
function l5change(p1,p2,p3,p4,p5:smallint):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l5max-1 do for j:=1 to l5max-1 do
     if genmask.l5[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if p3>=0 then begin
            if genmask.l5[i+k-1,j+l-1]=p3 then inc(c);
         end else begin
            if genmask.l5[i+k-1,j+l-1]<>abs(p3) then inc(c);
         end;
      if p2<=c then if random(2)=0 then tm.l5[i,j]:=p4 else tm.l5[i,j]:=p5;
   end;
   genmask:=tm;
end;
label l1,l2,l3,l4,l5,l6;
begin
//0- 1- 2- 3-
bsprites:=SpriteBases.current;
if bsprites=nil then bsprites:=SpriteBases.items[0];
randomize;
for i:=0 to 63 do
   for j:=0 to 63 do bout.data[i,j]:=0;
if fromlevel=1 then goto l1;
if fromlevel=2 then goto l2;
if fromlevel=3 then goto l3;
if fromlevel=4 then goto l4;
if fromlevel=5 then goto l5;
if fromlevel=6 then goto l6;

for i:=0 to l0max do for j:=0 to l0max do genmask.l1[i,j]:=genmask.l0[i,j];
l1:;
// 0
l1change(0,5,1,1);//    
//l1change(1,5,0,0);//    
//l1change(2,0,0,0);// 
//l1change(0,1,1,2);// 
// 
w:=0;l:=0;//b:=0;
for i:=l0cmin to l0cmax do
   for j:=l0cmin to l0cmax do begin
      if genmask.l1[i,j]=0 then inc(l);
      if genmask.l1[i,j]=1 then inc(w);
//      if genmask.l1[i,j]=2 then inc(b);
   end;
pass:=2;
if l>=8 then pass:=0;
if w>=8 then pass:=1;
if tolevel<=1 then exit;

//   2
for i:=0 to l0max do for j:=0 to l0max do begin
   genmask.l2[(i*2)+0,(j*2)+0]:=genmask.l1[i,j];genmask.l2[(i*2)+1,(j*2)+0]:=genmask.l1[i,j];
   genmask.l2[(i*2)+0,(j*2)+1]:=genmask.l1[i,j];genmask.l2[(i*2)+1,(j*2)+1]:=genmask.l1[i,j];
end;
if tolevel<=2 then exit;
l2:;
// 1
//l2change(0,5,1,1);//  5=
l2change(1,5,0,0);//    
l2change(0,1,1,1);//  
l2change(0,1,1,2);//  


//l2change(2,5,1,1);//  5=
//l2change(1,5,2,2);//  5=
//l2change(2,5,0,0);//  5=
//l2change(2,5,1,1);//  5=
//l2change(1,5,2,2);//  5=
//l2change(2,5,0,0);//  5=
//l2change(0,5,2,2);//  5=
//   3
for i:=0 to l2max do for j:=0 to l2max do begin
   genmask.l3[(i*2)+0,(j*2)+0]:=genmask.l2[i,j];genmask.l3[(i*2)+1,(j*2)+0]:=genmask.l2[i,j];
   genmask.l3[(i*2)+0,(j*2)+1]:=genmask.l2[i,j];genmask.l3[(i*2)+1,(j*2)+1]:=genmask.l2[i,j];
end;
// 2
l3change(0,5,1,1);//  5=
//l3change(0,2,1,1);//  5=
l3change(0,1,1,1);//  

//l3change(0,1,2,2);// 
//l3change(1,1,2,2);// 


l3change(2,4,1,1);//  5=
l3change(2,4,1,1);//  5=
l3change(1,5,2,2);//  5=
l3change(2,5,0,0);//  5=
l3change(0,5,2,2);//  5=
//l3change(2,3,1,3);//  
//l3change(1,1,2,3);//  
//   4
l3:;
if tolevel<=3 then exit;
for i:=0 to l3max do for j:=0 to l3max do begin
   genmask.l4[(i*2)+0,(j*2)+0]:=genmask.l3[i,j];genmask.l4[(i*2)+1,(j*2)+0]:=genmask.l3[i,j];
   genmask.l4[(i*2)+0,(j*2)+1]:=genmask.l3[i,j];genmask.l4[(i*2)+1,(j*2)+1]:=genmask.l3[i,j];
end;
l4:;
l4change(2,5,1,1);//     1/5
//l4change(2,5,1,1);//     1/5
//l4change(2,5,1,1);//     1/5
l4change(1,5,2,2);//     1/5
l4change(2,5,0,0);//     1/5
l4change(0,5,2,2);//     1/5
//l4change(3,5,1,1);//      1/5
//l4change(2,5,3,3);//      1/5
l4change(2,2,1,1);//  
//l4change(2,2,1,1);//  
//l4change(2,1,1,1);//  

if tolevel<=5 then exit;
//   5
for i:=0 to l4max do for j:=0 to l4max do begin
   genmask.l5[(i*2)+0,(j*2)+0]:=genmask.l4[i,j];genmask.l5[(i*2)+1,(j*2)+0]:=genmask.l4[i,j];
   genmask.l5[(i*2)+0,(j*2)+1]:=genmask.l4[i,j];genmask.l5[(i*2)+1,(j*2)+1]:=genmask.l4[i,j];
end;
l5:;
//l5change(2,1,1,1,1);//  
//l5change(2,1,1,1,1);//  
//l5change(2,1,0,0,0);//  
//l5change(2,1,0,0,0);//  

l5change(0,1,2,0,0);//  
l5change(0,1,2,0,2);//    
l5change(2,1,0,2,0);//    

l5change(2,1,1,2,1);//    
//l5change(2,1,1,2,1);//    

      l5change(1,1,2,2,3);//  
      l5change(1,1,2,3,4);//  

      l5change(1,1,3,4,5);//  
      l5change(1,1,4,5,6);//  

      l5change(1,1,5,6,7);//  
      l5change(1,1,6,7,8);//  

      l5change(1,1,7,8,9);//  
      l5change(1,1,8,9,10);//  

   //   l5change(1,1,4,4,6);//  
  //    l5change(1,1,4,5,5);//  
   //   l5change(1,1,5,5,6);//  

//      l5change(1,2,2,1,5);//  
//      l5change(1,2,3,1,5);//  
//      l5change(1,2,4,1,5);//  

  //    l5change(1,2,3,1,4);//  
//
//if bsprites.BeachItemsCount>=1 then begin
//   for i:=3 to 3+bsprites.BeachItemsCount do begin
//      l5change(1,2,i-1,1,i);//  
//   end;
//end;

//l5change(2,1,3,2,3);//     
//l5change(2,1,3,2,3);//     
//l5change(3,1,1,1,3);//     
// 
if tolevel<=6 then exit;
l6:;
if bsprites.WaterItemsCount>=0 then begin
   load(bsprites.Wateritems[random(bsprites.WaterItemsCount+1)]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         {if genmask.l5[i+2,j+2]=1 then} bout.data[i,j]:=tmpout.data[j,i];
end;
if bsprites.LandItemsCount>=0 then begin
   load(bsprites.landitems[random(bsprites.LandItemsCount+1)]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         if genmask.l5[i+l5cmin,j+l5cmin]=0 then bout.data[i,j]:=tmpout.data[i,j];
end;
if bsprites.BeachItemsCount>=0 then begin
   load(bsprites.Beachitems[0]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         if genmask.l5[i+l5cmin,j+l5cmin]=2 then bout.data[i,j]:=tmpout.data[i,j];
end;
if bsprites.BeachItemsCount>=1 then begin
   for l:=3 to (3+bsprites.BeachItemsCount-1) do begin
      load(bsprites.Beachitems[l-2]);
      for i:=0 to 63 do
         for j:=0 to 63 do
            if genmask.l5[i+l5cmin,j+l5cmin]=l then bout.data[i,j]:=tmpout.data[i,j];

   end;

end;
   for i:=0 to 63 do
      for j:=0 to 63 do
        temp.data[i,j]:=bout.data[j,i];

end;

procedure TSprGenerator.generatespriteEX;
var bsprites:TBMGSpriteCollection;
var bout2:Tbitmaps;
var bout:array[0..127,0..127]of byte;
//var bout3:array[0..127,0..127]of byte;
var i,j,k,l,wtr,lnd,bwt:integer;//  ,b  ,bch
procedure change(before, after: byte);
var f1,f2:integer;
begin
for f1:=0 to 127 do
   for f2:=0 to 127 do
      if bout[f1,f2]=before then bout[f1,f2]:=after;
end;
procedure SSchange(cur, findqty, find, setto1, setto2: byte);
var f3,f4,f5:byte;
var x,y:smallint;
var f1,f2:integer;
begin
for f1:=0 to 63 do
   for f2:=0 to 63 do begin
     if bout2.data[f1,f2]=cur then begin
      f5:=0;
      for f3:=0 to 2 do for f4:=0 to 2 do begin
         x:=(f1+f3-1);y:=(f2+f4-1);
         if (x>=0)and(x<=63)and(y>=0)and(y<=63){and((x<>1)and(y<>1))}then begin
            if bout2.data[x,y]=find then inc(f5);
         end;
      end;
      if findqty<=f5 then if brandom(2)=1 then bout2.data[f1,f2]:=setto1 else bout2.data[f1,f2]:=setto2;
     end;
   end;
end;

procedure Schange(cur, findqty, find, setto1, setto2: byte);
var f3,f4,f5:byte;
var x,y:smallint;
var f1,f2:integer;
begin
for f1:=0 to 127 do
   for f2:=0 to 127 do begin
     if bout[f1,f2]=cur then begin
      f5:=0;
      for f3:=0 to 2 do for f4:=0 to 2 do begin
         x:=(f1+f3-1);y:=(f2+f4-1);
         if (x>=0)and(x<=127)and(y>=0)and(y<=127){and((x<>1)and(y<>1))}then begin
            if bout[x,y]=find then inc(f5);
         end;
      end;
      if findqty<=f5 then if brandom(2)=1 then bout[f1,f2]:=setto1 else bout[f1,f2]:=setto2;
     end;
   end;
end;
begin
bsprites:=SpriteBases.current;
if bsprites=nil then bsprites:=SpriteBases.items[0];
randomize;wtr:=0;lnd:=0;bwt:=0;//bch:=0;
for i:=0 to 31 do
   for j:=0 to 31 do begin
     for k:=0 to 1 do
      for l:=0 to 1 do
         bout2.data[(i*2)+k,(j*2)+l]:=genmask.mskin2[i,j];
   end;
   SSchange(2,5,0,0,0);
   SSchange(3,5,2,2,2);
   SSchange(3,5,1,1,1);

for i:=0 to 63 do
   for j:=0 to 63 do begin
     for k:=0 to 1 do
      for l:=0 to 1 do
         bout[(i*2)+k,(j*2)+l]:=bout2.data[i,j];
   end;
  // mnt:=0;
//for i:=0 to 127 do   for j:=0 to 127 do      bout3[i,j]:=bout[i,j];
for i:=0 to 15 do
   for j:=0 to 15 do begin
     if genmask.mskin[i,j]=0 then inc(lnd);
     if genmask.mskin[i,j]=1 then inc(wtr);
     if (genmask.mskin[i,j]>=2){and(genmask.mskin[i,j]<90) }then inc(bwt);
    // if genmask.mskin[i,j]=90 then inc(mnt);
   end;
pass:=2;
if lnd>150 then pass:=0;
if (wtr)>150 then pass:=1;
//if mnt>200 then pass:=3;
   Schange(2,5,0,0,0);
   Schange(3,5,2,2,2);
 //  Schange(2,4,3,20,30);change(30,3);change(20,2);
   Schange(3,5,1,1,1);

   Schange(2,1,3,20,30);change(30,3);change(20,2);
   Schange(2,1,3,20,30);change(30,3);change(20,2);

for i:=0 to 63 do
   for j:=0 to 63 do begin
     if bout[i+32,j+32]=0 then inc(lnd);
     if bout[i+32,j+32]=1 then inc(wtr);
     if bout[i+32,j+32]>=2 then inc(bwt);
   end;
temp.purewater:=2;
if (lnd=0)and(bwt=0)then temp.purewater:=1;
if (wtr=0)and(bwt=0)then temp.purewater:=0;
if bwt>0 then begin
begin
   change(3,20);
   for i:=3 to 15 do Schange(20,2,i-1,i,i);
   for i:=3 to 11 do begin
      Schange(i,0,i,i,i+1);//Schange(i+1,1,i-1,i+1,i+1);change(15,i);
   end;
end;
end;

for i:=0 to 63 do
   for j:=0 to 63 do begin
      genmask.sFinal.data[j,i]:=bout[i+32,j+32];
   end;

bout2:=bsprites.getsprite(genmask.sFinal);

genmask.sFinal.pass:=pass;
genmask.sFinal.kind:=1;
genmask.sFinal.idInTileset:=bout2.idInTileset;
genmask.sFinal.allowAnim:=bout2.allowAnim;
temp.allowAnim:=bout2.allowAnim;
temp.idInTileset:=bout2.idInTileset;
genmask.sFinal.purewater:=temp.purewater;
genmask.sFinal.pass:=pass;
temp.pass:=pass;

   for i:=0 to 63 do
      for j:=0 to 63 do
        temp.data[i,j]:=bout2.data[i,j];


end;

procedure TSprGenerator.GenerateSpriteWithALLCol;
var f1,f2,i,j:integer;
var c:byte;
begin
c:=0;
for f1:=0 to 15 do
   for f2:=0 to 15 do begin
      for i:=0 to 3 do
       for j:=0 to 3 do
          tmpout.data[(f1*4)+i,(f2*4)+j]:=c;
    inc(c);
   end;
end;

procedure TSprGenerator.GenerateSpriteWithNumber(num: integer;color:byte;background:byte);
var bmp:Pbitmap;
var f1,f2:integer;
begin
bmp:=NewBitmap(64,64);
//for f1:=
bmp.Canvas.Brush.Color:=clWhite;
bmp.Canvas.FillRect(bmp.canvas.ClipRect);
f1:=bmp.Canvas.TextWidth(int2str(num));
f2:=bmp.Canvas.TextHeight(int2str(num));
bmp.Canvas.TextOut(32-(f1 div 2),32-(f2 div 2),int2str(num));
for f1:=0 to 63 do
   for f2:=0 to 63 do
     if bmp.Canvas.Pixels[f1,f2]=clWhite then tmpout.data[f2,f1]:=background else tmpout.data[f2,f1]:=color;
tmpout.pass:=0;
bmp.Free;
end;

function TSprGenerator.generateSprPalette(mp:TDPalette):boolean;
var f1,f2,f3,f5:integer;
var c:byte;
var r:single;
begin
result:=false;
     for f2:=0 to sprw-1 do
      for f3:=0 to sprh-1 do begin
         c:=sprdata[f2,f3];
         if colorID[c]=300 then begin
            f5:=-1;
            //     
            for f1:=0 to 255 do begin
               if (f1>=160)or((f1>32)and(f1<64))then begin
                 if (mp[f1].rgb.rgbBlue=mpalette[c].rgb.rgbBlue)and
                    (mp[f1].rgb.rgbGreen=mpalette[c].rgb.rgbGreen)and
                    (mp[f1].rgb.rgbRed=mpalette[c].rgb.rgbRed)then f5:=f1;
                 end;
            end;
            if f5=-1 then begin
               //    
               r:=0.05;// - 5%
               for f1:=0 to 255 do begin
               if (f1>=160){or((f1>32)and(f1<64))}then begin
                 if nearcolor(mp[f1].rgb.rgbBlue,mpalette[c].rgb.rgbBlue,r) and
                    nearcolor(mp[f1].rgb.rgbGreen,mpalette[c].rgb.rgbGreen,r) and
                    nearcolor(mp[f1].rgb.rgbRed,mpalette[c].rgb.rgbRed,r) then f5:=f1;
               end;
               end;
            end;
            if f5=-1 then begin
            //  
               for f1:=64 to 159 do begin
                 if (colorQTY[f1]<>0)and(colorID[f1]=300)then f5:=f1;
               end;
            end;
            if f5=-1 then begin
               showmessage(' .           .      (   64-70 ).'+#13#10+
                           'Not possible. Bitmap has more colors than free cells in MAX palette. You may load other MAX map or decrease colors in BMP file (no more than 64, but i think you may try 75).');
               exit;
            end;
            colorID[c]:=f5;
            colorQty[f5]:=0;
         end;
         sprdata[f2,f3]:=colorID[c];
      end;
// 
for f1:=0 to 255 do sbh.p[f1].color:=0;
for f1:=0 to 255 do begin
   if colorID[f1]<>300 then begin
      sbh.p[colorID[f1]].color:=mpalette[f1].color;
   end;
end;
//9,10,11,12 -   
//13,14,15,16 -   
//17,18,19,20 -   
//21,22,23,24 -   
//25,26,27,28,29,30 -    
//31 -  
//96-109 -    
//110,111,112,113 -     
//114,115,116 -      
//117-122 -  123-127 -  
for f1:=9 to 31 do begin sbh.p[f1].color:=mp[f1].color;end;
for f1:=96 to 127 do begin sbh.p[f1].color:=mp[f1].color;end;

mpalette:=sbh.p;
result:=true;
end;

procedure TSprGenerator.GenerateTechnoDemoMapForSprite(id: integer;percTo:Pcontrol);
var tmp:PmaxMap;
var f1,f2,f3,mx,cr:integer;
var bmp:Pbitmap;
var ss:string;
begin
if percto<>nil then ss:=percto.caption;
tmp:=NewMaxMap;
cr:=0;mx:=259;
tmp.mapsize.x:=112;
tmp.mapsize.y:=112;
tmp.Data.mapsize:=tmp.mapsize.arr;
bmp:=NewBitmap(112,112);
bmp.Canvas.Brush.Color:=clWhite;
bmp.Canvas.FillRect(bmp.canvas.ClipRect);
f1:=bmp.Canvas.TextWidth('TechnoDemo#'+int2str(id));
f2:=bmp.Canvas.TextHeight('TechnoDemo#'+int2str(id));
bmp.Canvas.Font.FontStyle:=[fsBold];
bmp.Canvas.Font.Color:=clBlack;
bmp.Canvas.Font.FontHeight:=15;
bmp.Canvas.TextOut(66-(f1 div 2),16-(f2 div 2),'TechnoDemo#'+int2str(id));
for f1:=0 to 111 do
   for f2:=0 to 111 do
     if bmp.Canvas.Pixels[f1,f2]=clWhite then tmp.data.minimap[f2,f1]:=160 else tmp.data.minimap[f2,f1]:=103;
bmp.Free;
for f1:=0 to 63 do
   for f2:=0 to 63 do
     tmp.data.minimap[f2+30,f1+30]:=temp.data[f2,f1];

for f1:=0 to 111 do
   for f2:=0 to 111 do
      tmp.Data.map[f1,f2].idword:=207;
//tmp.addMapItem(temp);
f1:=0;f2:=0;
for f3:=0 to 255 do begin
   GenerateSpriteWithNumber(f3,207,f3);
   tmp.addMapItem(tmpout);
   tmp.Data.map[f2,f1].idword:=f3;
   inc(f1);if f1>15 then begin f1:=0;inc(f2);end;
   inc(cr);if percto<>nil then begin percto.caption:=int2str(trunc((cr/mx)*100))+' %';applet.ProcessMessages;end;

end;
//temp:=maxmap.data.bitmaps[id];
//calcsprcolors;
//dothis('DeleteWaterFromGenerator');
for f1:=0 to 63 do
   for f2:=0 to 63 do begin
//      GenerateSpriteWithNumber(tmpout[f1,f2],207,tmpout[f1,f2]);
      tmp.Data.map[f1+20,f2+20].idword:=temp.data[f1,f2];
   end;
   tmp.addMapItem(temp);
for f1:=0 to 63 do begin
   tmp.Data.map[f1+9,111].idword:=256;
end;
GenerateSpriteWithALLCol;
   tmp.addMapItem(tmpout);
for f1:=0 to 10 do begin
   tmp.Data.map[20+(f1*2),5].idword:=257;
end;
//for f1:=0 to 63 do
//   for f2:=0 to 63 do begin
//      GenerateSpriteWithNumber(tmpout[f1,f2],207,tmpout[f1,f2]);
//      tmp.Data.map[f1+65,f2+10].idword:=temp.data[f1,f2];
//   end;

tmp.Data.Mpalette:=maxmap.Data.Mpalette;
tmp.saveMaxFile(getstartdir,'DemoMap'+int2str(id));
free_and_nil(tmp);
if percto<>nil then percto.caption:=ss;
end;

function TSprGenerator.getgeneratorbitmap(num: smallint): Pbitmap;
var stream:Pstream;
begin
result:=nil;
if loaded then begin
randomizespr;
result:=NewBitmap(64,64);
stream:=NewMemoryStream;
saveSpriteToStream(stream,num);
stream.Position:=0;
result.LoadFromStream(stream);
stream.Free;
end;
end;

function TSprGenerator.getSprbitmap: Pbitmap;
var stream:Pstream;
begin
result:=nil;
if sprok=1 then begin
result:=NewBitmap(64,64);
stream:=NewMemoryStream;
saveSprToStream(stream);
stream.Position:=0;
result.LoadFromStream(stream);
stream.Free;
end;

end;

procedure TSprGenerator.getSprColors(whereto: PControl);
var f2:word;
begin
whereto.Clear;
if loaded=false then exit;
   calcsprcolors;
   // 
   while whereto.LVColCount<1 do whereto.LVColAdd('',taLeft,200);
   for f2:=0 to colorcount do begin
       whereto.LVItemAdd(' '+int2str(colorID[f2])+' - '+int2str(colorQTY[f2])+' ');
   end;
end;

procedure TSprGenerator.load(maxbmp: Tbitmaps);
begin
temp:=maxbmp;
tmpout:=maxbmp;
loaded:=true;
end;

procedure TSprGenerator.load(srcb: TSRCBitmap);
var f1:integer;
begin
if srcb.kind=1 then load(srcb.Bitmap);
if srcb.kind=2 then begin
   colorcount:=srcb.colcount;
   setlength(colorID,colorcount+1);
   setlength(colorQTY,colorcount+1);
   for f1:=0 to colorcount do begin
      colorID[f1]:=srcb.colID[f1];
      colorQTY[f1]:=srcb.colQTY[f1];
   end;
   randomizespr;
end;
end;

procedure TSprGenerator.load(filename: string);
var f1,f2:integer;
var stream:PStream;
var b:byte;
begin
sprok:=0;
if not(fileexists(filename))then exit;
stream:=NewReadFileStream(filename);
stream.Read(sbh.f.Typf,2);//bh.f.Typf:=ord('B')+(ord('M')*256);
if sbh.f.Typf<>(ord('B')+(ord('M')*256)) then begin Stream.Free;showmessage('File must be 256 color BMP'); exit;end;
stream.Read(sbh.f.Size,4);//bh.f.Size:=(112*112)+1078;
stream.Read(sbh.f.Res1,2);//bh.f.Res1:=0;
stream.Read(sbh.f.Res2,2);//bh.f.Res2:=0;
stream.Read(sbh.f.OfBm,4);sbh.f.OfBm:=1078;
//if sbh.f.OfBm<>1078 then begin Stream.Free;showmessage('File must be 256 color BMP'); exit;end;
stream.Read(sbh.i.Size,4);//bh.i.Size:=40;
stream.Read(sbh.i.Widt,4);//bh.i.Widt:=112;
sprw:=sbh.i.Widt;
sprw:=(sprw div 4)*4;
if sprw<>sbh.i.Widt then sprw:=sprw+4;
stream.Read(sbh.i.Heig,4);//bh.i.Heig:=112;
sprh:=sbh.i.Heig;
stream.Read(sbh.i.Plan,2);//bh.i.Plan:=1;
stream.Read(sbh.i.BitC,2);//bh.i.BitC:=8;
if sbh.i.BitC<>8 then begin Stream.Free;showmessage('File must be 256 color BMP'); exit;end;
stream.Read(sbh.i.Comp,4);//bh.i.Comp:=0;
stream.Read(sbh.i.SizI,4);//bh.i.SizI:=112*112;
stream.Read(sbh.i.XppM,4);//bh.i.XppM:=0;
stream.Read(sbh.i.YppM,4);//bh.i.YppM:=0;
stream.Read(sbh.i.NCoL,4);//bh.i.NCoL:=256;
stream.Read(sbh.i.NCoI,4);//bh.i.NCoI:=256;
for f1:=0 to 255 do sbh.p[f1].color:=0;
stream.Read(sbh.p,sbh.i.NCoL*4);//1024);//bh.p:=data.Mpalette;
mpalette:=sbh.p;
setlength(sprdata,sprw+1,sprh+1);
for f2:=sprh-1 downto 0 do
   for f1:=0 to sprw-1 do begin
      stream.Read(b,1);
      sprdata[f1,f2]:=b;
   end;
sprok:=1;
stream.free;
end;

procedure TSprGenerator.makesprite(posx, posy: integer);
var i,j,x,y:integer;
begin
   lastposx:=posx;lastposy:=posy;
   if ((posx+63)>=sprw)or((posy+63)>=sprh)or(posx<0)or(posy<0)then begin
      showmessage('Out of range');exit;
   end;
for i:=0 to 63 do
   for j:=0 to 63 do begin
      x:=posx+i;
      y:=posy+j;
      temp.data[j,i]:=sprdata[x,y];
   end;

end;

function TSprGenerator.nearcolor(c1, c2: byte; match: single): boolean;
var rr:single;
var mn,mx:byte;
begin
   rr:=match+1;
   if c1>c2 then begin mn:=c2;mx:=c1;end else begin mn:=c1;mx:=c2;end;
   if (mn<>0) and (mx<>0) then rr:=1-(mn / mx);
   if (mn=0) and (mx=0) then rr:=0;
   if (mn=0) and (mx<>0) then rr:=(mx / 255);
   if rr<=match then result:=true else result:=false;
end;

procedure TSprGenerator.randomizespr;
var f1,f2,f3,f5:integer;
begin
     colorcount:=high(colorID);
     if colorcount<=0 then exit;
     //,    
     f3:=colorQTY[1];
     f5:=1;
     for f2:=1 to colorCount do
        if (f3<colorQTY[f2])and(colorID[F2]<>0) then begin f3:=colorQTY[f2];f5:=f2;end;
     //     
     for f1:=0 to 63 do
      for f2:=0 to 63 do
       tmpOUT.data[f1,f2]:=colorID[f5];
     //      
     for f1:=0 to colorCount do
      if (colorID[f1]<>0)and(f1<>f5) then
      for f2:=0 to trunc((colorQTY[f1]/f3)*1096) do
       tmpOUT.data[random(64),random(64)]:=colorID[f1];
end;

procedure TSprGenerator.removecolors(fromBmp: TBitmaps;toId:byte);
var f1,f2,f3:integer;
begin
calcsprcolors;
for f1:=0 to 63 do
   for f2:=0 to 63 do
      for f3:=0 to colorcount do
         if colorID[f3]=fromBMP.data[f1,f2] then colorQTY[f3]:=50000;
for f3:=0 to colorcount do
   if colorQTY[f3]=50000 then changecolor(f3,0,toId);
calcsprcolors;
end;

procedure TSprGenerator.removecolors(fromBmp: TSRCBitmap;toId:byte=0);
var f1:integer;
begin
if fromBMp.kind=1 then removecolors(fromBMP.Bitmap,toid);
if fromBMP.kind=2 then begin
calcsprcolors;
   for f1:=1 to fromBmp.colcount do begin
      changecolor(fromBmp.colID[f1],0,toid);
   end;
calcsprcolors;
end;
end;

procedure TSprGenerator.saveAnimatedWaterSpriteToStreamAsPCX(strm: PStream;
  inout: byte;hqanim:boolean);
var ph:TPCXHeader;
var i,j:word;
var b,c,cur,fc:byte;
var p:array of array of byte;
var cl:array [0..255]of byte;
begin
//96-109 -    
//110,111,112,113 -     
//114,115,116 -      
//117-122 -  123-127 -  
if hqanim then fc:=14 else fc:=7;//tt:=0;
for i:=0 to 255 do cl[i]:=i;
if hqanim=false then begin
   for i:=0 to 6 do cl[96+(i*2)+1]:=cl[96+(i*2)];
   for i:=0 to 2 do cl[117+(i*2)+1]:=cl[117+(i*2)];
   for i:=0 to 1 do cl[123+(i*2)+1]:=cl[123+(i*2)];cl[127]:=cl[126];
end;
setlength(p,64*fc,64);
if inout=1 then begin
for cur:=0 to fc-1 do begin
for i:=0 to 63 do
   for j:=0 to 63 do //tmpout
//      p[(cur*64)+i,j]:=cl[tmpout.data[j,i]-96];
      p[(cur*64)+i,j]:=cl[tmpout.data[j,i]];
//c:=cl[0];for i:=1 to 13 do cl[i-1]:=cl[i];cl[13]:=c;
//if hqanim=false then begin
//if tt=0 then begin
//   c:=cl[96];
//   for i:=97 to 109 do cl[i-1]:=cl[i];
//   cl[109]:=c;
//   inc(tt);
//end else if tt>=2 then tt:=0;
//end else begin
   c:=cl[96];for i:=97 to 109 do cl[i-1]:=cl[i];cl[109]:=c;//tt:=1;
   c:=cl[114];for i:=115 to 116 do cl[i-1]:=cl[i];cl[116]:=c;//tt:=1;
   c:=cl[117];for i:=118 to 122 do cl[i-1]:=cl[i];cl[122]:=c;//tt:=1;
   c:=cl[123];for i:=124 to 127 do cl[i-1]:=cl[i];cl[127]:=c;//tt:=1;
//end;
//if hqanim=false then begin c:=cl[96];for i:=97 to 109 do cl[i-1]:=cl[i];cl[109]:=c;end;
end;
end;
if inout=2 then begin
for cur:=0 to fc-1 do begin
for i:=0 to 63 do
   for j:=0 to 63 do
//      p[(cur*64)+i,j]:=cl[temp.data[j,i]-96];
      p[(cur*64)+i,j]:=cl[temp.data[j,i]];
//c:=cl[0];for i:=1 to 13 do cl[i-1]:=cl[i];cl[13]:=c;
   c:=cl[96];for i:=97 to 109 do cl[i-1]:=cl[i];cl[109]:=c;//tt:=1;
   c:=cl[114];for i:=115 to 116 do cl[i-1]:=cl[i];cl[116]:=c;//tt:=1;
   c:=cl[117];for i:=118 to 122 do cl[i-1]:=cl[i];cl[122]:=c;//tt:=1;
   c:=cl[123];for i:=124 to 127 do cl[i-1]:=cl[i];cl[127]:=c;//tt:=1;
//if hqanim=false then begin c:=cl[96];for i:=97 to 109 do cl[i-1]:=cl[i];cl[109]:=c;end;
end;
end;
  ph.Manufacturer      :=10; //  10 = ZSoft .PCX
  ph.Version           :=5; //0 =  2.5
                              //2 =  2.8    
                              //3 =  2.8    
                              //5 =  3.0
  ph.Encoding          :=1; //1 = .PCX   
  ph.BitsPerPixel      :=8; //     
  ph.Xmin              :=0; //  (Xmin, Ymin) - (Xmax, Ymax)   
  ph.Ymin              :=0;
  ph.Xmax              :=(64*fc)-1;
  ph.Ymax              :=63;
  ph.Hres              :=144; //   
  ph.Vres              :=144; //   
 for i:=0 to 15 do begin
  ph.ColorMap[i].R:=0;
  ph.ColorMap[i].G:=0;
  ph.ColorMap[i].B:=0;
 end;
  ph.Reserved          :=0;
  ph.NPlanes           :=1; //  
  ph.BytesPerLine      :=64*fc; //      
                              //( PCX-    )
  ph.PaletteInfo       :=1; //  :
                              //1 = /-,
                              //2 =  
  for i:=0 to 58 do
   ph.Filler[i]:=0; // 
//------------
  strm.Write(ph,128);
//------------
   b:=193;
begin
  for j:=0 to 63 do
    for i:=0 to ((64*fc)-1) do begin
       strm.Write(b,1);
       strm.Write(p[i,j],1);
    end;
end;
{begin
for j:=0 to 63 do begin
    cur:=p[0,j];c:=1;//s:=1;
  for i:=1 to ((64*14)-1) do begin
       if (p[i,j]=cur) then begin
          inc(c);
       end else begin
          if c=1 then begin
             if cur>=192 then begin
                b:=193;
                strm.Write(b,1);
             end;
             strm.Write(cur,1);
             cur:=p[i,j];
             c:=1;
          end else begin
             b:=192+c;
             strm.Write(b,1);
             strm.Write(cur,1);
             cur:=p[i,j];
             c:=1;
          end;
    end;
       if i=((64*14)-1) then begin
       b:=192+c;
       strm.Write(b,1);
       strm.Write(cur,1);
       end;
    end;
  end;
end;}
   b:=12;
for i:=0 to 255 do begin
   strm.Write(mpalette[i].rgb.rgbRed,1);
   strm.Write(mpalette[i].rgb.rgbGreen,1);
   strm.Write(mpalette[i].rgb.rgbBlue,1);
end;
setlength(p,0,0);

end;

procedure TSprGenerator.saveSpriteToStream(strm: PStream;inout:byte);
var  bh:bmHeader;
var i1,i2:byte;
var ln:array[0..63]of byte;
begin
strm.Position:=0;
bh.f.Typf:=ord('B')+(ord('M')*256);
bh.f.Res1:=0;
bh.f.Res2:=0;
bh.f.OfBm:=1078;
bh.i.Size:=40;
bh.i.Plan:=1;
bh.i.BitC:=8;
bh.i.Comp:=0;
bh.f.Size:=(64*64)+1078;
bh.i.Widt:=64;
bh.i.Heig:=64;
bh.i.SizI:=64*64;
bh.i.XppM:=0;
bh.i.YppM:=0;
bh.i.NCoL:=256;
bh.i.NCoI:=256;
bh.p:=Mpalette;
//for i1:=0 to 255 do begin        //----+-
//   bh.p[i1][0]:=data.Mpalette[i1].rbg.rgbRed;//,3];//112233
//   bh.p[i1][1]:=data.Mpalette[i1].rbg.rgbGreen;//,2];//231321
//   bh.p[i1][2]:=data.Mpalette[i1].rbg.rgbBlue;//,1];//323112
//   bh.p[i1][0]:=data.Mpalette[i1,3];//112233
//   bh.p[i1][1]:=data.Mpalette[i1,2];//231321
//   bh.p[i1][2]:=data.Mpalette[i1,1];//323112
//end;
strm.Write(bh.f.Typf,2);
strm.Write(bh.f.Size,4);
strm.Write(bh.f.Res1,2);
strm.Write(bh.f.Res2,2);
strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);
strm.Write(bh.i.Widt,4);
strm.Write(bh.i.Heig,4);
strm.Write(bh.i.Plan,2);
strm.Write(bh.i.BitC,2);
strm.Write(bh.i.Comp,4);
strm.Write(bh.i.SizI,4);
strm.Write(bh.i.XppM,4);
strm.Write(bh.i.YppM,4);
strm.Write(bh.i.NCoL,4);
strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
if inout=1 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=tmpout.data[63-i1,i2];
   strm.Write(ln,64);
end;
end;
if inout=2 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=temp.data[63-i1,i2];
   strm.Write(ln,64);
end;
end;

end;

procedure TSprGenerator.saveSpriteToStreamAsPCX(strm: PStream;
  inout: byte);
var ph:TPCXHeader;
var i,j,b:byte; //,c,cur ,s
begin
  ph.Manufacturer      :=10; //  10 = ZSoft .PCX
  ph.Version           :=5; //0 =  2.5
                              //2 =  2.8    
                              //3 =  2.8    
                              //5 =  3.0
  ph.Encoding          :=1; //1 = .PCX   
  ph.BitsPerPixel      :=8; //     
  ph.Xmin              :=0; //  (Xmin, Ymin) - (Xmax, Ymax)   
  ph.Ymin              :=0;
  ph.Xmax              :=63;
  ph.Ymax              :=63;
  ph.Hres              :=144; //   
  ph.Vres              :=144; //   
 for i:=0 to 15 do begin
  ph.ColorMap[i].R:=0;
  ph.ColorMap[i].G:=0;
  ph.ColorMap[i].B:=0;
 end;
  ph.Reserved          :=0;
  ph.NPlanes           :=1; //  
  ph.BytesPerLine      :=64; //      
                              //( PCX-    )
  ph.PaletteInfo       :=1; //  :
                              //1 = /-,
                              //2 =  
  for i:=0 to 58 do
   ph.Filler[i]:=0; // 
//------------
  strm.Write(ph,128);
//------------
   b:=193;
if inout=1 then begin
  for i:=0 to 63 do
    for j:=0 to 63 do begin
       strm.Write(b,1);
       strm.Write(tmpout.data[i,j],1);
    end;
end;
{if inout=1 then begin
  for i:=0 to 63 do begin
    cur:=tmpout.data[i,0];c:=1;
    for j:=1 to 63 do begin
       if (tmpout.data[i,j]=cur) then begin
          inc(c);
       end else begin
          if c=1 then begin
             if cur>=192 then begin
                b:=193;
                strm.Write(b,1);
             end;
             strm.Write(cur,1);
             cur:=tmpout.data[i,j];
             c:=1;
          end else begin
             b:=192+c;
             strm.Write(b,1);
             strm.Write(cur,1);
             cur:=tmpout.data[i,j];
             c:=1;
          end;
    end;
       if (j=63) then begin
       b:=192+c;
       strm.Write(b,1);
       strm.Write(cur,1);
       end;
    end;
  end;
end;

if inout=2 then begin
  for i:=0 to 63 do begin
    cur:=temp.data[i,0];
    for j:=1 to 63 do begin
       if (temp.data[i,j]=cur) then begin
          inc(c);
       end else begin
          if c=1 then begin
             if cur>=192 then begin
                b:=193;
                strm.Write(b,1);
             end;
             strm.Write(cur,1);
             cur:=temp.data[i,j];
             c:=1;
          end else begin
             b:=192+c;
             strm.Write(b,1);
             strm.Write(cur,1);
             cur:=temp.data[i,j];
             c:=1;
          end;
       end;
       if (j=63) then begin
       b:=192+c;
       strm.Write(b,1);
       strm.Write(cur,1);
       end;
    end;
  end;
end;
     }
   b:=193;
if inout=2 then begin
  for i:=0 to 63 do
    for j:=0 to 63 do begin
       strm.Write(b,1);
       strm.Write(temp.data[i,j],1);
    end;
end;
   b:=12;
for i:=0 to 255 do begin
   strm.Write(mpalette[i].rgb.rgbRed,1);
   strm.Write(mpalette[i].rgb.rgbGreen,1);
   strm.Write(mpalette[i].rgb.rgbBlue,1);
end;
end;

procedure TSprGenerator.saveSprToStream(strm: PStream);
var f1,f2:integer;
begin
if sprok<>1 then exit;
strm.Write(sbh.f.Typf,2);
strm.Write(sbh.f.Size,4);
strm.Write(sbh.f.Res1,2);
strm.Write(sbh.f.Res2,2);
strm.Write(sbh.f.OfBm,4);
strm.Write(sbh.i.Size,4);
strm.Write(sbh.i.Widt,4);
strm.Write(sbh.i.Heig,4);
strm.Write(sbh.i.Plan,2);
strm.Write(sbh.i.BitC,2);
strm.Write(sbh.i.Comp,4);
strm.Write(sbh.i.SizI,4);
strm.Write(sbh.i.XppM,4);
strm.Write(sbh.i.YppM,4);
strm.Write(sbh.i.NCoL,4);
strm.Write(sbh.i.NCoI,4);
strm.Write(mpalette,1024);
for f2:=sprh-1 downto 0 do
   for f1:=0 to sprw-1 do
      strm.Write(sprdata[f1,f2],1);
end;

procedure TSprGenerator.setSprColors(from: PControl);
var f1,f2:word;
begin
if loaded=false then exit;
   for f2:=0 to from.LVCount-1 do begin
      for f1:=0 to colorcount do begin

      end;
//       whereto.LVItemAdd(' '+int2str(colorID[f2])+' - '+int2str(colorQTY[f2])+' ');
   end;
end;

initialization
Generator:=nil;
Generator2:=nil;
finalization
if Generator<>nil then Generator.Free;
generator:=nil;
if Generator2<>nil then Generator2.Free;
generator2:=nil;
end.
