unit BMaxGDraw;

interface
uses windows,kol,BMGMaxMap,BMaxGTypes,BMaxGGameMap, BProcsPack, BMaxGObject;
type PBmaxCrsr=^TBmaxCrsr;
   TBmaxCrsr=object(TObj)
   Objs:array of PMaxGoldObject;
   objcount:integer;

   pixpos:TXY;

   Draw:TMaxGFunc;
   LeftclickOnEmptyCell:TMaxGFunc;
   LeftclickOnMyUnit:TMaxGFunc;
   LeftClickOnEnemyUnit:TMaxGFunc;
   procedure go(func:string;button:integer=-1);
   destructor destroy;virtual;
   procedure clear;
end;
type PBmaxDraw=^TBmaxDraw;
   TBmaxDraw=object(TObj)
   cursor:PBmaxCrsr;
   map0:PBitmap;
   outscreen,flipscreen:Pbitmap;
   repaint:boolean;
   maxmap:PMaxMap;
   mapdetail,lastmdet:byte;
   pos:txy;

   dpx,dpy:single;
   scrw,scrdw:txy;
   srcCW:integer;
   Cellw:integer;
   showsectors:boolean;
   nodrawnow:boolean;
   src,dst:Trect;
   Muse: TMouseEventData;
   procedure Draw(Sender: PControl; DC: HDC);overload;
   procedure draw(dorepaint:boolean=false);overload;
   destructor destroy;virtual;
   procedure setmaxmap(newmaxmap:PMaxMap);
   procedure setmapdetail(newDetail:integer);
   procedure setOutWnd(Paintbox:Pcontrol);
   procedure useMMoveFrom(control:Pcontrol);
   procedure useWheelFrom(control:Pcontrol);
   procedure ResizeForm(control:PObj);
   procedure ReleaseOutWnd;
   procedure Wheel(Sender: PControl;var Mouse: TMouseEventData);
   procedure MMove(Sender: PControl;var Mouse: TMouseEventData);
   procedure MDown(Sender: PControl;var Mouse: TMouseEventData);
   procedure MapClick(Sender: PObj);
   procedure MapDblClick(Sender: PControl;var Mouse: TMouseEventData);
   procedure setmaxframerate(fps:integer);
   function cellpos2pix(ps:Txy):Txy;
   function pix2cellpos(ps:Txy):Txy;
   private
   Timer:PTimer;
   oldOnPaint:TOnPaint;
   oldOnResize:TOnEvent;
   OutWnd:Pcontrol;
   procedure onTimer(Sender: Pobj);
   function getmap(detail:byte=0):Pbitmap;
   function minimumcellw(mx,my:integer):integer;
   procedure scrwh(mx,my:integer);
end;
function NewMaxDraw:PBmaxDraw;
function NewCursor:PBmaxCrsr;
implementation
uses main, BMaxGPlayer, BMaxGUnitsInfo;
function NewCursor:PBmaxCrsr;
begin
{$IFDEF BMGLOG}log('function NewCursor:PBmaxCrsr;');{$ENDIF}
   new(result,create);
   Glsr[IDCursor]:=result;
   setlength(result.objs,0);
   result.objcount:=-1;
   result.draw:=nil;
   result.LeftclickOnEmptyCell:=nil;
   result.LeftclickOnMyUnit:=nil;
   result.LeftClickOnEnemyUnit:=nil;

end;
function NewMaxDraw:PBmaxDraw;
begin
{$IFDEF BMGLOG}log('function NewMaxDraw:PBmaxDraw;');{$ENDIF}
   new(result,create);
   Glsr[IDMdraw]:=result;
   result.cursor:=NewCursor;
   result.OutWnd:=nil;
   result.lastmdet:=255;
   result.map0:=nil;
 result.maxmap:=nil;

   result.Cellw:=0;
   result.outscreen:=nil;
   result.mapdetail:=32;
   result.repaint:=true;
   result.pos.X:=0;
   result.pos.Y:=0;
   result.dpx:=0;
   result.dpy:=0;
   result.nodrawnow:=false;
   result.Timer:=NewTimer(100);
   result.Timer.Enabled:=false;
   result.Timer.OnTimer:=result.onTimer;
   result.showsectors:=false;
end;

function TBmaxDraw.minimumcellw(mx, my: integer): integer;
var cx,cy:integer;
begin
{$IFDEF BMGLOG}log('function TBmaxDraw.minimumcellw(mx='+int2str(mx)+', my='+int2str(my)+': integer): integer;');{$ENDIF}

   cx:=trunc(mx / maxmap.mapsize.x);
   cy:=trunc(my / maxmap.mapsize.y);
   if cy<cx then cellw:=cy else cellw:=cx;
   if cellw=0 then cellw:=1;
   result:=cellw;
   scrwh(mx,my);
end;

destructor TBmaxDraw.destroy;
begin
{$IFDEF BMGLOG}log('destructor TBmaxDraw.destroy;');{$ENDIF}

   if cursor<>nil then cursor.Free;cursor:=nil;
   ReleaseOutWnd;
   Timer.Free;timer:=nil;
   maxmap:=nil;
   if map0<>nil then map0.Free;map0:=nil;

   Cellw:=0;
   if outscreen<>nil then outscreen.Free;
   outscreen:=nil;
end;

procedure TBmaxDraw.Draw(Sender: PControl; DC: HDC);
var w,h:integer;
var lup:txy;
var d:byte;
var gmap:PGameMap;
begin
if nodrawnow then exit;
nodrawnow:=true;
gmap:=PGameMap(Glsr[IDGameMap]);

if repaint=false then begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.Draw(Sender: PControl; DC: HDC);(repaint=false))');{$ENDIF}
   outscreen.Draw(flipscreen.canvas.Handle,0,0);
   gmap.drawUnits;
   if assigned(cursor.draw) then cursor.go('Draw');
   flipscreen.Draw(sender.canvas.Handle,0,0);
   nodrawnow:=false;
   exit;
end;
{$IFDEF BMGLOG}log('procedure TBmaxDraw.Draw(Sender: PControl; DC: HDC);(repaint=true))');{$ENDIF}

if outscreen=nil then begin
   outscreen:=NewBitmap(sender.Width,sender.Height);
   flipscreen:=NewBitmap(sender.Width,sender.Height);
end;
if cellw=0 then cellw:=minimumcellw(sender.Width,sender.Height) else scrwh(sender.Width,sender.Height);

     if cellw>48 then d:=1 else
     if cellw>31 then d:=2 else
    if cellw>20 then d:=4 else
   if cellw>10 then d:=8 else
  if cellw>5 then d:=16 else
 if cellw>2 then d:=32 else d:=64;
if d<mapdetail then d:=mapdetail;
if d<>lastmdet then begin lastmdet:=d;
   getmap(d);
end;
if map0=nil then getmap(d);
lup.X:=pos.X-trunc(scrw.X / 2);
lup.Y:=pos.Y-trunc(scrw.Y / 2);
src.Left:=(lup.x*srcCW);if src.Left<0 then src.Left:=0;
src.Top:=(lup.y*srcCW);if src.Top<0 then src.top:=0;
src.Right:=src.Left+(scrw.X*srcCW);
if src.Right>=map0.Width then begin
   src.Right:=map0.Width;
   src.Left:=src.Right-(scrw.X*srcCW);
   if src.left<0 then src.Left:=0;
end;
src.Bottom:=src.Top+(scrw.Y*srcCW);                    
if src.Bottom>=map0.Height then begin
   src.Bottom:=map0.Height;
   src.Top:=src.Bottom-(scrw.Y*srcCW);
   if src.top<0 then src.Top:=0;
end;
dst.Left:=trunc(outscreen.Width / 2)-(( trunc(((src.Right-src.Left)/srcCW)/2) )*(cellw))-trunc(dpx);
dst.Top:=trunc(outscreen.Height / 2)-(trunc(((src.Bottom-src.Top)/srcCW)/2)*(cellw))-trunc(dpy);
dst.Right:=dst.Left+(trunc(((src.Right-src.Left)/srcCW))*(cellw));
dst.Bottom:=dst.Top+(trunc(((src.Bottom-src.Top)/srcCW))*(cellw));

if src.Left>=srcCW then begin src.Left:=src.Left-srcCW;dst.Left:=dst.Left-cellw;end;
if src.Left>=srcCW then begin src.Left:=src.Left-srcCW;dst.Left:=dst.Left-cellw;end;
if src.Top>=srcCW then begin src.Top:=src.Top-srcCW;dst.Top:=dst.Top-cellw;end;
if src.Bottom<=(map0.Height-srcCW) then begin src.Bottom:=src.Bottom+srcCW;dst.Bottom:=dst.Bottom+cellw;end;
if src.Right<=(map0.Width-srcCW) then begin src.Right:=src.Right+srcCW;dst.Right:=dst.Right+cellw;end;

w:=outscreen.Width-(dst.Right-dst.Left);
h:=outscreen.Height-(dst.Bottom-dst.Top);
if (w>0)or (h>0) then begin
   outscreen.Canvas.Brush.Color:=clgray;
   outscreen.Canvas.FillRect(outscreen.canvas.ClipRect);
end;

outscreen.CopyRect(dst,map0,src);

h:=dst.Left;
repeat

   outscreen.Canvas.MoveTo(h,dst.Top);outscreen.Canvas.LineTo(h,dst.Bottom);
   h:=h+(cellw+0);

until h>dst.Right;
h:=dst.Top;
repeat

   outscreen.Canvas.MoveTo(dst.Left,h);outscreen.Canvas.LineTo(dst.Right,h);
   h:=h+(cellw+0);

until h>dst.Bottom;

gmap.drawUnits;
repaint:=false;
outscreen.Draw(flipscreen.canvas.Handle,0,0);
gmap.drawUnits;
if assigned(cursor.draw) then cursor.go('Draw');
flipscreen.Draw(sender.canvas.Handle,0,0);
{$IFDEF BMGLOG}log('END TBmaxDraw.Draw');{$ENDIF}
nodrawnow:=false;
end;

function TBmaxDraw.getmap(detail:byte): Pbitmap;

begin
{$IFDEF BMGLOG}log('function TBmaxDraw.getmap(detail:byte='+int2str(detail)+'): Pbitmap;');{$ENDIF}
result:=nil;
if maxmap=nil then exit;
if map0<>nil then map0.Free;
if detail=0 then detail:=mapdetail;
map0:=maxmap.getMapBitmap(detail,PGameMap(Glsr[IDGamemap]).mask);
applet.ProcessMessages;
result:=map0;
srcCW:=trunc(int(map0.Width / maxmap.mapsize.x));
end;

procedure TBmaxDraw.scrwh(mx, my: integer);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.scrwh(mx='+int2str(mx)+', my='+int2str(my)+': integer);');{$ENDIF}
   scrw.X:=trunc(mx / cellw);if scrw.X>maxmap.mapsize.x then scrw.X:=maxmap.mapsize.x;
   scrw.Y:=trunc(my / cellw);if scrw.Y>maxmap.mapsize.y then scrw.Y:=maxmap.mapsize.y;
   scrdw.X:=trunc(scrw.X / 2);
   scrdw.Y:=trunc(scrw.Y / 2);
end;

procedure TBmaxDraw.setmaxmap(newmaxmap: PMaxMap);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.setmaxmap(newmaxmap: PMaxMap);');{$ENDIF}
   maxmap:=newmaxmap;
   if map0<>nil then map0.Free;map0:=nil;
   repaint:=true;
end;

procedure TBmaxDraw.setmapdetail(newDetail: integer);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.setmapdetail(newDetail: integer);');{$ENDIF}
   mapdetail:=newdetail;
   if map0<>nil then map0.Free;map0:=nil;
   repaint:=true;
end;

procedure TBmaxDraw.setOutWnd(Paintbox: Pcontrol);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.setOutWnd(Paintbox: Pcontrol);');{$ENDIF}

   oldOnPaint:=paintbox.OnPaint;
   paintbox.OnMouseDown:=MDown;
   paintbox.OnClick:=MapClick;
   paintbox.OnMouseDblClk:=MapDblClick;
  paintbox.OnMouseMove:=MMove;
   oldOnResize:=paintbox.OnResize;
   paintbox.OnResize:=ResizeForm;
   OutWnd:=paintbox;
   paintbox.OnPaint:=Draw;
end;

procedure TBmaxDraw.ReleaseOutWnd;
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.ReleaseOutWnd;');{$ENDIF}
   if outwnd=nil then exit;
   OutWnd.OnPaint:=oldOnPaint;
   OutWnd.OnResize:=oldOnResize;
   OutWnd.OnClick:=nil;
   OutWnd.OnMouseDblClk:=nil;
   OutWnd.OnMouseMove:=nil;
   OutWnd:=nil;
end;

procedure TBmaxDraw.useWheelFrom(control: Pcontrol);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.useWheelFrom(control: Pcontrol);');{$ENDIF}
control.OnMouseWheel:=wheel;
end;

procedure TBmaxDraw.Wheel(Sender: PControl; var Mouse: TMouseEventData);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.Wheel(Sender: PControl; var Mouse: TMouseEventData);');{$ENDIF}
cellw:=cellw+(2*trunc(smallint(hiword(mouse.Shift))/abs(smallint(hiword(mouse.Shift)))));
if cellw<2 then cellw:=2;
if cellw>64 then cellw:=64;
repaint:=true;
timer.Enabled:=true;
end;

procedure TBmaxDraw.onTimer(Sender: Pobj);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.onTimer(Sender: Pobj);');{$ENDIF}
timer.Enabled:=false;
draw(OutWnd,OutWnd.canvas.Handle);
end;

procedure TBmaxDraw.MMove(Sender: PControl; var Mouse: TMouseEventData);
var dx,dy:smallint;
{$IFDEF BMGLOG}var mappos:TXY;gmap:PGamemap;unt:PUnitUpgradeHistory;{$ENDIF}
begin

if sender=outwnd then begin
if (mouse.shift=MK_RBUTTON)or(mouse.shift=MK_LBUTTON+MK_RBUTTON) then begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.MMove(Sender: PControl; var Mouse: TMouseEventData{RBUTTON});');{$ENDIF}
   dx:=(cursor.pixpos.X-mouse.X);
   dy:=(cursor.pixpos.Y-mouse.Y);
   if dx<0 then if pos.x>=scrdw.X then dpx:=dpx+dx else dpx:=0;
   if dx>0 then if pos.x<=(maxmap.mapsize.x-scrdw.X) then dpx:=dpx+dx else dpx:=0;
   if dy<0 then if pos.y>=scrdw.Y then dpy:=dpy+dy else dpy:=0;
   if dy>0 then if pos.y<=(maxmap.mapsize.y-scrdw.Y) then dpy:=dpy+dy else dpy:=0;

   if dpx<(-cellw) then while dpx<=(-cellw) do begin dpx:=dpx+cellw;if pos.x>=scrdw.X then pos.X:=pos.X-1 else dpx:=0;end;
   if dpx>(cellw) then while dpx>=(cellw) do begin dpx:=dpx-cellw;if pos.x<=(maxmap.mapsize.x-scrdw.x) then pos.X:=pos.X+1 else dpx:=0;end;
   if dpy<(-cellw) then while dpy<=(-cellw) do begin dpy:=dpy+cellw;if pos.y>=scrdw.Y then pos.Y:=pos.y-1 else dpy:=0;end;
   if dpy>(cellw) then while dpy>=(cellw) do begin dpy:=dpy-cellw;if pos.y<=(maxmap.mapsize.y-scrdw.Y) then pos.Y:=pos.y+1 else dpy:=0;end;
   repaint:=true;
   timer.Enabled:=true;
end;
cursor.pixpos.x:=mouse.X;cursor.pixpos.Y:=mouse.Y;
{$IFDEF BMGLOG}gmap:=PGamemap(glsr[IDGameMap]);unt:=PUnitUpgradeHistory(glsr[IDUnitInfo]);if gmap<>nil then begin mappos:=pix2cellpos(cursor.pixpos);if unt<>nil then gmap.positionfree(mappos,unt);if (mappos.x>=0) and (mappos.y>=0) then main.Form1.GroupBox13.caption:=xy2log(mappos)+'terr='+ terr2log(gmap.Cells[mappos.x,mappos.y].terrtype)+' maxpass='+int2str(gmap.maxmap.getmaxpass(mappos.x,mappos.y));end;{$ENDIF}
end;

if sender=form1.ListBox4 then begin
   cursor.pixpos.x:=mouse.X-form1.ListBox4.Width;cursor.pixpos.Y:=mouse.Y;
end;
if assigned(cursor.draw) then timer.Enabled:=true;
end;

procedure TBmaxDraw.setmaxframerate(fps: integer);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.setmaxframerate(fps: integer='+int2str(fps)+');');{$ENDIF}
if fps>1000 then fps:=1000;
timer.interval:=trunc(abs(1000/fps));
end;

procedure TBmaxDraw.ResizeForm(control: PObj);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.ResizeForm(control: PObj);');{$ENDIF}
if outscreen<>nil then outscreen.Free;
outscreen:=nil;
repaint:=true;
timer.Enabled:=true;

end;

procedure TBmaxDraw.Draw(dorepaint:boolean);
begin
if dorepaint then begin map0.Free;map0:=nil;repaint:=true;end;
{$IFDEF BMGLOG}log('procedure TBmaxDraw.Draw(dorepaint:boolean);');{$ENDIF}

timer.Enabled:=true;
end;

procedure TBmaxDraw.useMMoveFrom(control: Pcontrol);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.useWheelFrom(control: Pcontrol);');{$ENDIF}
control.OnMouseMove:=mmove;
end;

procedure TBmaxDraw.MDown(Sender: PControl; var Mouse: TMouseEventData);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.MDown(Sender: PControl; var Mouse: TMouseEventData);');{$ENDIF}
muse:=mouse;
end;

function TBmaxDraw.cellpos2pix(ps: Txy): Txy;
begin
   result.x:=dst.left+((ps.x-trunc(src.left/srcCW))*CellW);
   result.y:=dst.top +((ps.y-trunc(src.top /srcCW))*CellW);
end;

function TBmaxDraw.pix2cellpos(ps: Txy): Txy;
begin
result:=xy(-1,-1);
if dst.Right=dst.Left then exit;
if dst.Bottom=dst.Top then exit;
if srcCW=0 then exit;
      result.x:=trunc(((((ps.x-dst.Left)*(src.Right-src.Left))/(dst.Right-dst.Left))+src.Left)/srcCW);
      result.y:=trunc(((((ps.y-dst.Top)*(src.Bottom-src.Top))/(dst.Bottom-dst.Top))+src.Top)/srcCW);

end;

procedure TBmaxDraw.MapClick(Sender: PObj);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.MapClick(Sender: PObj);');{$ENDIF}
if (muse.Shift=MK_LBUTTON)or(muse.Shift=MK_LBUTTON+MK_SHIFT)or(muse.Shift=MK_LBUTTON+MK_RBUTTON) then begin
   cursor.go('LClick',muse.Shift);
 end;
end;

procedure TBmaxDraw.MapDblClick(Sender: PControl;
  var Mouse: TMouseEventData);
begin
{$IFDEF BMGLOG}log('procedure TBmaxDraw.MapDblClick(Sender: PControl;var Mouse: TMouseEventData);');{$ENDIF}
mapclick(sender);
end;

destructor TBmaxCrsr.destroy;
begin
{$IFDEF BMGLOG}log('destructor TBmaxCrsr.destroy;');{$ENDIF}
clear;
inherited;
end;

procedure TBmaxCrsr.go(func: string;button:integer);
var tmap:PGameMap;
var sr:Theader;
var drw:PBMaxDraw;

var cll:PGameMapCell;
var tfunc:TMaxGFunc;
function UnitLeftClick(clt:byte):boolean;
var f1:integer;
begin
result:=false;
for f1:=0 to objcount do
   if objs[f1]<>nil then begin
      tfunc:=getfunc(objs[f1].func,clt);
      if assigned(tfunc) then begin
         glsr[IDUnit]:=objs[f1];
         tfunc(glsr);
         result:=true;
      end;
   end;
end;
begin
if func='Draw' then draw(glsr);
if func='LClick' then begin
   {$IFDEF BMGLOG}log('procedure TBmaxCrsr.go(func: string='''+func+''';button:integer);');{$ENDIF}
   tmap:=PGameMap(glsr[IDGameMap]);
   drw:=PBMaxDraw(glsr[IDMdraw]);
   cll:=tmap.cell(drw.pix2cellpos(pixpos));
   glsr[IDMapCell]:=cll;
   if cll=nil then exit;
   sr:=cll.UnitsIn;
   if sr[1]>0 then begin
      if UnitLeftClick(FTLeftClickOnMyUnit) then exit;
      if assigned(LeftclickOnMyUnit) then LeftclickOnMyUnit(glsr);
      exit;
   end;
   if sr[2]>0 then begin
      if UnitLeftClick(FTLeftClickOnEnemy) then exit;
      if assigned(LeftClickOnEnemyUnit) then LeftClickOnEnemyUnit(glsr);
      exit;
   end;
   if (sr[1]=0)and(sr[2]=0) then begin
      if UnitLeftClick(FTLeftClickOnEmpty) then exit;
      if assigned(leftclickOnEmptyCell) then leftclickOnEmptyCell(glsr);
      exit;
   end;
end;
end;

procedure TBmaxCrsr.clear;
var f1:integer;
begin
{$IFDEF BMGLOG}log('procedure TBmaxCrsr.clear;');{$ENDIF}
   Draw:=nil;
   for f1:=0 to high(objs) do objs[f1]:=nil;setlength(objs,0);objs:=nil;
   LeftclickOnEmptyCell:=nil;
   LeftclickOnMyUnit:=ppck.SelectMyUnit;
   LeftClickOnEnemyUnit:=nil;
end;

end.

