unit BMaxGMapGenerator;

interface
uses windows,kol,BMaxGTypes,BMGSpritegenerator,BMGSpriteCollection;
type tstrp=record
   pos:TXY;
   length:array of TXY;
end;
type idXY=record
   pos:TXY;
   id:word;
end;
type tstripes=record
   startpos:TXY;
   length:array of tstrp;

end;
type Tislands=record
   pos:TXY;
   r:array[0..360]of byte;
end;
type tcacheitem=record
   msk:TgenIN;
   SFinal:array of Tbitmaps;
   PosInFile:cardinal;
   TilesetName:String;
   hq:boolean;
   animwater:boolean;
   hqanim:boolean
end;
type genmapitem=record
   msk:tgenIN;
   msk2:tgenIN2;
   spr:Tbitmaps;
   sfinal:Tbitmaps;
   pass:byte;
   mmFileName:String;

end;
type PMapGenerator=^TMapGenerator;
   TMapGenerator=object(TObj)
   logIread:integer;
   logIcheck:integer;
   logIfound:integer;
   logIwrite:integer;
   cloc:string;
   cachecount:integer;
   cfsize:cardinal;
   cache:array of tcacheitem;
   cacheloaded:boolean;
   tileset:TBMGSpriteCollection;
   placedobtacles:array of idXY;
   placedobtaclescount:integer;
   stripes:array of Tstripes;slengthmax,SLength,Swidth:integer;scount,scur:integer;
   billiard:array of txy;bSize:word;bCount,bCur:integer;
   islands:array of Tislands;iSize:word;iCount,iCur:integer;
   Ilislands,IlLakes:array of Tislands;iLiSize,iLlsize:word;ilICount,iLLCount,iliCur,iLLCur:integer;
   Cross:array of Tislands;CrSize,CrWidth,CrIWidth:word;CrLength:integer;
   SpWidth,SpStep,SpStart:integer;

   SwCur:integer;
   chSize:integer;
   mapsize,rmapsize,hqmapsize:TmapSizeEx;
   mpalette:TDPalette;
   gmask:tgenl0;
   gmaskl2:tgenl2;
   preview:PBitmap;
   rseed:integer;
   mapitems:array of genmapitem;
   mapitemsQTY:array of integer;
   mapitemscount:integer;
   handpos:array of TXY;
   handmp:array of byte;
   handW:array of byte;
   hcount:integer;
   mapdata:array of array of byte;
   HQmapdata:array of array of byte;
   readymapdata:array of array of word;
   readyminimap:array of array of byte;
   mask:array of array of byte;
   placeobtacles:boolean;
   ObtaclesOnCorner:boolean;
   ObtaclesOnLand:boolean;
   ObtaclesCount:word;
   LowQuality:boolean;
   ULowQuality:boolean;
   HQuality:boolean;
   flatbeach,tilesetcolor:boolean;
   stop,usepreset,flatminimap,addpodp:boolean;
   sfile,podp:string;
   bm2:array of array of byte;
   tbm3:TBitmaps;
   gml:byte;
   destructor destroy;virtual;
   procedure generatepreviewdata;
   procedure generatepreview(ml:byte=1);
   procedure compilemap(fromscratch:boolean=true;percto:PControl=nil);
   procedure savetomaxmap;
   procedure savetoMMmap(percTo:Pcontrol;fname:string;hq:boolean;animwater:boolean;hqanim:boolean;useMMwaterOnly:byte=255);
   procedure saveBMGFile(dir,fname:string);
   procedure LoadBMGFile(dir,fname:string);
   function getpreviewbitmap:Pbitmap;
   function getreadyminimapbitmap:Pbitmap;
   procedure addhand(x,y:integer;mb:byte;percx10:byte=10);
   private
   procedure loadcache;

   procedure placeobtacle(pos:Txy;radius:word;obID:integer=-1;checkfor:boolean=true;addnew:boolean=false);
   procedure placeland(pos:txy;radius:word;invert:boolean=false;ml:byte=1);
   procedure placesqrland(pos:txy;size:word;invert:boolean=false;ml:byte=1);
   procedure placeIsland(island:tislands;radius:word;invert:boolean=false;ml:byte=1);
   procedure savePrewiveBitmaptostream(strm: PStream;ml:byte=1);
   procedure saveReadyMinimaptostream(strm: PStream);
   function itemID(msk:tgenIN):integer;
   function addmapitem(msk:tgenIN;msk2:tgenIN2;savetocache:boolean=false):integer;overload;
   function addmapitem(msk:tgenIN;sfinal:TBitmaps):integer;overload;
   function addmapitem(bm:TBitmaps):word;overload;
   function addmapitem(cacheID:integer):word;overload;
   procedure mapchange(before,after,ml:byte);overload;
   procedure mapchange(cur,findqty,find,setto1,setto2,ml:byte);overload;
end;
function NewMapGenerator:PMapGenerator;
var rpos:integer;
var rmax:integer;
var mapgen:PMapGenerator;
{$i BmaxRndData.pas}
function brandom(nummax:integer):integer;
function brandomize:integer;
implementation
uses MapGeneratorMain;
function brandomize:integer;
begin
randomize;
rpos:=random(rmax-1)+1;
result:=rpos;
end;
function brandom(nummax:integer):integer;
begin
result:=trunc(nummax*rnddata[rpos]/10000);
inc(rpos);if rpos>rmax then rpos:=1;
end;
function NewMapGenerator:PMapGenerator;
begin
   new(result,create);
   result.sfile:='';
   result.podp:='';

   result.addpodp:=false;
   result.cachecount:=-1;
   setlength(result.cache,0);
   result.cacheloaded:=false;
   setlength(result.placedobtacles,0);
   result.placedobtaclescount:=-1;
   setlength(result.mapitems,0); setlength(result.mapitemsQTY,0);
   setlength(result.readymapdata,0,0);
   setlength(result.readyminimap,0,0);
   result.mapitemscount:=-1;
   setlength(result.stripes,0);
   result.preview:=nil;
   result.tileset:=nil;
   result.flatminimap:=false;
   result.flatbeach:=false;
   result.tilesetcolor:=true;
   result.LowQuality:=false;
   result.ULowQuality:=false;
   setlength(result.handpos,0);
   setlength(result.handmp,0);
   setlength(result.handw,0);
   result.hcount:=-1;
   result.stop:=true;
   result.usepreset:=false;
end;

procedure TMapGenerator.addhand(x, y: integer; mb: byte;percx10:byte);
begin
inc(hcount);
setlength(handpos,hcount+1);
setlength(handmp,hcount+1);
setlength(handw,hcount+1);
handpos[hcount]:=XY(x div (2*gml),y div (2*gml));
handmp[hcount]:=mb;
handW[hcount]:=percx10;
end;

function TMapGenerator.addmapitem(msk:tgenIN;msk2:tgenIN2;savetocache:boolean):integer;

var p:Pstream;
var ss:string;

begin
inc(mapitemscount);
setlength(mapitems,mapitemscount+1);
setlength(mapitemsQTY,mapitemscount+1);
mapitemsQTY[mapitemscount]:=0;
mapitems[mapitemscount].msk:=msk;
mapitems[mapitemscount].msk2:=msk2;

generator.genmask.mskin:=msk;
generator.genmask.mskin2:=msk2;
generator.generatespriteEX;
mapitems[mapitemscount].spr:=generator.temp;
mapitems[mapitemscount].sFinal:=generator.genmask.sFinal;
mapitems[mapitemscount].pass:=generator.pass;
mapitems[mapitemscount].sFinal.pass:=generator.pass;

result:=mapitemscount;
if savetocache then begin

   inc(logIwrite);
   inc(cachecount);cloc:=cloc+','+int2str(cachecount);
   logIread:=cachecount+1;
   setlength(cache,cachecount+1);
   cache[cachecount].msk:=msk;
   setlength(cache[cachecount].SFinal,0);

   ss:=getstartdir+'GenCache.res';
   p:=NewReadWriteFileStream(ss);
   p.seek(0,spBegin);
   p.Write(cachecount,sizeof(cachecount));
   p.Seek(0,spEnd);
   p.Write(msk,256);
   cache[cachecount].PosInFile:=p.Position;cloc:=cloc+'('+int2str(cache[cachecount].PosInFile)+')';
   p.Write(mapitems[mapitemscount].sFinal,sizeof(mapitems[mapitemscount].sFinal));

   p.Free;
end;
end;

function TMapGenerator.addmapitem(bm: TBitmaps):word;
var f1,f2,f3,f4:integer;
begin
for f1:=mapitemscount downto 0 do begin
   f4:=0;
   for f2:=0 to 63 do
      for f3:=0 to 63 do begin
         if mapitems[f1].spr.data[f2,f3]<>bm.data[f2,f3] then f4:=1;
      end;
   if mapitems[f1].pass<>bm.pass then f4:=1;
   if f4=0 then begin
      result:=f1;exit;
   end;
end;
inc(mapitemscount);
setlength(mapitems,mapitemscount+1);
setlength(mapitemsQTY,mapitemscount+1);
mapitemsQTY[mapitemscount]:=0;
for f1:=0 to 15 do
   for f2:=0 to 15 do
     mapitems[mapitemscount].msk[f1,f2]:=5;
mapitems[mapitemscount].sfinal:=bm;
mapitems[mapitemscount].spr:=bm;
mapitems[mapitemscount].pass:=bm.pass;
result:=mapitemscount;
end;

procedure TMapGenerator.compilemap(fromscratch:boolean=true;percto:PControl=nil);
var f1,f2,f3,f4,f5,dt,cur,max,ml:integer;
var cllr:array[0..4]of byte;
var tmp:TgenIN;
    tmp2:tgenIN2;
    f:Pstream;
    b1,b2:byte;
    bm1:PBitmap;
var osb:TBMGSpriteCollection;
procedure rndmapitems(f,t:word);
var i,j:integer;
begin
for i:=0 to mapsize.x-1 do
   for j:=0 to mapsize.y-1 do
      if readymapdata[i,j]=f then
        if random(2)=1 then readymapdata[i,j]:=t;
end;
begin

if cacheloaded=false then begin
   loadcache;
end;
   logIcheck:=0;
   logIfound:=0;
   logIwrite:=0;  cloc:='';
rpos:=rseed;
ml:=16;
generatepreview(ml);
dt:=0;
osb:=nil;
if fromscratch then begin
   setlength(placedobtacles,0);
   placedobtaclescount:=-1;
   setlength(mapitems,0);
   setlength(mapitemsQTY,0);
   mapitemscount:=-1;
end;
if tileset=nil then begin dt:=1;
   if SpriteBases=nil then exit;
   if SpriteBases.current=nil then exit;
   tileset:=SpriteBases.current;
end else begin
   osb:=SpriteBases.current;
   SpriteBases.current:=tileset;
end;
generator.mpalette:=tileset.Mpalette;
mpalette:=tileset.Mpalette;
if tileset.LandItemsCount>=0 then begin
   f1:=0;
   if tileset.LandItems[f1].kind=1 then cllr[0]:=tileset.LandItems[f1].Bitmap.data[32,32];
   if tileset.LandItems[f1].kind=2 then cllr[0]:=tileset.LandItems[f1].colID[1];
end;
if tileset.WaterItemsCount>=0 then begin
   f1:=0;
   if tileset.WaterItems[f1].kind=1 then cllr[1]:=tileset.WaterItems[f1].Bitmap.data[32,32];
   if tileset.WaterItems[f1].kind=2 then cllr[1]:=tileset.WaterItems[f1].colID[1];
end;
if tileset.BeachItemsCount>=0 then begin
   if tileset.BeachItems[0].kind=1 then cllr[2]:=tileset.BeachItems[0].Bitmap.data[32,32];
   if tileset.BeachItems[0].kind=2 then cllr[2]:=tileset.BeachItems[0].colID[1];
end else cllr[2]:=cllr[0];
if tileset.BeachItemsCount>=1 then begin
   if tileset.BeachItems[1].kind=1 then cllr[3]:=tileset.BeachItems[2].Bitmap.data[32,32];
   if tileset.BeachItems[1].kind=2 then cllr[3]:=tileset.BeachItems[2].colID[1];
end else cllr[3]:=cllr[1];
max:=mapsize.x;cur:=0;

if fromscratch then begin
setlength(readymapdata,mapsize.x,mapsize.y);
setlength(readyminimap,mapsize.x,mapsize.y);
if percto<>nil then begin
   PercTO.caption:='Preparing...';
   applet.processmessages;
end;
mapchange(0,5,1,1,1,ml);mapchange(0,4,1,6,6,ml);mapchange(6,1,ml);
mapchange(0,1,1,2,2,ml);mapchange(0,3,2,5,5,ml);mapchange(5,2,ml);
mapchange(1,1,2,3,3,ml);
mapchange(1,1,3,4,4,ml);mapchange(4,3,ml);

for f1:=1 to mapsize.x do begin
   for f2:=1 to mapsize.y do begin
      for f3:=0 to 15 do
        for f4:=0 to 15 do
          tmp[f3,f4]:=mapdata[(f1*ml)+f3,(f2*ml)+f4];
      if stop then begin
            if dt=1 then tileset:=nil else spritebases.current:=osb;
            generatepreview;exit;
      end;
       f5:=itemID(tmp);
       if f5=-1 then begin
         for f3:=0 to 31 do
         for f4:=0 to 31 do
            tmp2[f3,f4]:=mapdata[(f1*ml)+f3-8,(f2*ml)+f4-8];
         f5:=addmapitem(tmp,tmp2,true);
       end;
      readymapdata[f2-1,f1-1]:=f5;
      readyminimap[f2-1,f1-1]:=cllr[mapitems[f5].pass];
   end;
inc(cur);if percto<>nil then begin
   PercTO.caption:='Map '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
end;

if (Ulowquality=false)then begin
f3:=0;
if Lowquality=false then f3:=2;
if Hquality then f3:=4;
for f4:=0 to f3 do begin
f2:=mapitemscount;
for f1:=0 to f2 do begin
   if mapitemsqty[f1]>20 then begin
      f5:=addmapitem(mapitems[f1].msk,mapitems[f1].Sfinal);
      rndmapitems(f1,f5);
   end;
   mapitemsqty[f1]:=0;
end;
for f1:=0 to mapsize.x-1 do
   for f2:=0 to mapsize.y-1 do
     inc(mapitemsQty[readymapdata[f1,f2]]);
end;
end;
max:=0;cur:=0;
if ObtaclesOnCorner then begin inc(max,mapsize.x);inc(max,mapsize.y);end;
if ObtaclesOnLand then inc(max,ObtaclesCount);

if placeobtacles=false then begin
  if (sfile<>'')then begin
   f3:=-1;
   if tileset.ObtaclesCount>=0 then begin
      for f1:=0 to tileset.ObtaclesCount do begin
      if (tileset.Obtacles[f1].width=1)and(tileset.Obtacles[f1].height=1)then f3:=f1;
      end;
   end;
   f:=NewReadFileStream(sfile);
   f.Seek(224,spBegin);
for f2:=0 to 111 do
   for f1:=0 to 111 do begin
      f.Read(b1,1);b2:=5;
      case b1 of
      1: b2:=0;
      2: b2:=1;
      4: b2:=2;
      end;
      if ((f3>=0)and(b2=5))then begin
         placeobtacle(xy(f2,f1),1,f3,false,true);
      end;

   end;
   f.Free;
   end;
 end;
if placeobtacles then begin
   if ObtaclesOnCorner then begin
      for f1:=0 to mapsize.x-1 do begin
          if mapitems[readymapdata[f1,0]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(f1,0),10);
          end;
          if mapitems[readymapdata[f1,mapsize.y-1]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(f1,mapsize.y-1),10);
          end;
inc(cur);if percto<>nil then begin
   PercTO.caption:='Beach 100% Obtacles '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
      end;
      for f1:=0 to mapsize.y-1 do begin
          if mapitems[readymapdata[0,f1]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(0,f1),10);
          end;
          if mapitems[readymapdata[mapsize.x-1,f1]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(mapsize.x-1,f1),10);
          end;
inc(cur);if percto<>nil then begin
   PercTO.caption:='Beach 100% Obtacles '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
      end;
   end;
   if ObtaclesOnLand then begin;
   for f1:=0 to ObtaclesCount do begin
         f3:=brandom(mapsize.x);
         f2:=brandom(mapsize.y);
         placeobtacle(xy(f3,f2),10);
inc(cur);if percto<>nil then begin
   PercTO.caption:='Beach 100% Obtacles '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
      end;
   end;
end;
if flatminimap=false then begin
for f1:=0 to mapsize.x-1 do
   for f2:=0 to mapsize.y-1 do
      readyminimap[f1,f2]:=mapitems[readymapdata[f1,f2]].spr.data[32,32];
end;
end;
if fromscratch=false then begin
   for f1:=0 to mapitemscount do begin
      generator.genmask.mskin:=mapitems[f1].msk;
      generator.generatesprite;

      mapitems[f1].spr:=generator.temp;
   end;
   for f1:=0 to placedobtaclescount do begin
      placeobtacle(placedobtacles[f1].pos,10,placedobtacles[f1].id,false);
   end;
end;
if addpodp then begin
bm1:=NewBitmap(100,64);
bm1.Canvas.Font.FontHeight:=20;
bm1.Canvas.Font.FontStyle:=[fsBold];
f1:=bm1.Canvas.TextWidth(podp);
f2:=bm1.Canvas.TextHeight(podp);
f3:=(trunc(f1 / 64)+1)*64;
if f3>((mapsize.x-1)*64)then f3:=((mapsize.x-1)*64);
if f3>((mapsize.y-1)*64)then f3:=((mapsize.y-1)*64);
bm1.Free;
bm1:=NewBitmap(f3,64);
bm1.Canvas.Brush.Color:=clWhite;
bm1.Canvas.FillRect(bm1.canvas.ClipRect);
bm1.Canvas.Font.FontHeight:=20;
bm1.Canvas.Font.FontStyle:=[fsBold];
bm1.Canvas.Font.Color:=clBlack;
bm1.Canvas.TextOut((f3 div 2)-(f1 div 2),32-(f2 div 2),podp);
for f1:=1 to (f3-1) do
   for f2:=1 to (63-1) do begin
     f5:=0;
     for b1:=0 to 2 do
     for b2:=0 to 2 do
        if bm1.Canvas.Pixels[f1+b1-1,f2+b2-1]=clBlack then inc(f5);
     if (f5>0)and(bm1.Canvas.Pixels[f1,f2]=clWhite) then bm1.Canvas.Pixels[f1,f2]:=clRed;
   end;
setlength(bm2,f3,64);
for f1:=0 to (f3 div 64)-1 do begin
   for b1:=0 to 63 do
     for b2:=0 to 63 do
        bm2[(f1*64)+b1,b2]:=mapitems[readymapdata[mapsize.y-1,mapsize.x-(f3 div 64)+f1]].spr.data[b2,b1];
end;
for f1:=0 to f3-1 do
   for f2:=0 to 63 do begin
      if bm1.Canvas.Pixels[f1,f2]=clRed then bm2[f1,f2]:=160;
      if bm1.Canvas.Pixels[f1,f2]=clBlack then bm2[f1,f2]:=100;
   end;
for f1:=0 to (f3 div 64)-1 do begin
  tbm3:=mapitems[readymapdata[mapsize.y-1,mapsize.x-(f3 div 64)+f1]].spr;
  for b1:=0 to 63 do
     for b2:=0 to 63 do
        tbm3.data[b2,b1]:=bm2[(f1*64)+b1,b2];
   readymapdata[mapsize.y-1,mapsize.x-(f3 div 64)+f1]:=addmapitem(tbm3);
end;

bm1.Free;
setlength(bm2,0,0);
end;
if dt=1 then tileset:=nil else spritebases.current:=osb;
generatepreview;

end;

destructor TMapGenerator.destroy;
 var f1,f2:integer;
begin
   setlength(podp,0);

   setlength(sfile,0);
   cachecount:=-1;
   for f1:=0 to high(cache) do setlength(cache[f1].SFinal,0);
   setlength(cache,0);
   cacheloaded:=false;
   if tileset<>nil then tileset.free;
   tileset:=nil;
   setlength(placedobtacles,0);
   placedobtaclescount:=-1;

   setlength(readymapdata,0,0);
   setlength(readyminimap,0,0);
   setlength(mapitems,0); setlength(mapitemsQTY,0);
   mapitemscount:=-1;
   setlength(handpos,0);
   setlength(handmp,0);
   setlength(handw,0);
   hcount:=-1;
for f1:=0 to high(stripes)do begin
   for f2:=0 to high(stripes[f1].length) do
      setlength(stripes[f1].length[f2].length,0);
   setlength(stripes[f1].length,0);
   stripes[f1].length:=nil;

end;
setlength(stripes,0);
stripes:=nil;
setlength(billiard,0);
setlength(islands,0);
setlength(Ilislands,0);
setlength(IlLakes,0);
setlength(Cross,0);

if preview<>nil then preview.Free;
preview:=nil;
inherited;
end;

procedure TMapGenerator.generatepreview(ml:byte=1);
var f1,f2,F3,f4,i,j:integer;
var r,r2:single;
var b1,b2:byte;
var f:Pstream;
begin sfile:='';if ml=0 then ml:=1;
gml:=ml;
SCur:=Form1.scrollbar6.SBPosition;
SLength:=Form1.scrollbar7.SBPosition;
if preview<>nil then preview.Free;preview:=nil;
setlength(mapdata,(rmapsize.x*ml)+1,(rmapsize.y*ml)+1);
for f1:=0 to (rmapsize.x*ml) do
   for f2:=0 to (rmapsize.y*ml) do
      mapdata[f1,f2]:=1;
rpos:=rseed;

if form1.radiobox28.checked then begin
   if (fileexists(form1.editbox25.text))then begin
   sfile:=form1.editbox25.text;
   f:=NewReadFileStream(form1.editbox25.text);
   f.Seek(224,spBegin);
for f2:=0 to 111 do
   for f1:=0 to 111 do begin
      f.Read(b1,1);
      case b1 of
      1: b2:=0;
      2: b2:=1;
      4: b2:=2;
      else b2:=0;
      end;
      for i:=0 to ml+1 do
         for j:=0 to ml+1 do
            mapdata[(f1*ml)+i+ml,(f2*ml)+j+ml]:=b2;

   end;
   f.Free;
   end else begin
      end;
end;

if form1.radiobox27.checked then begin
setlength(mask,(ml*2)+1,(ml*2)+1);
for i:=0 to ml do
  for j:=0 to ml do begin
     if ((i*i)+(j*j))<=(ml*ml) then f3:=0 else f3:=1;
     mask[ml-i,ml-j]:=f3;mask[i+ml,ml-j]:=f3;
     mask[ml-i,ml+j]:=f3;mask[i+ml,ml+j]:=f3;
end;

   CrWidth:=Form1.scrollbar23.SBPosition;
   CrLength:=Form1.scrollbar22.SBPosition;
   for f1:=4 to CrLength+3 do
      placeIsland(cross[f1],CrWidth,false,ml);
   CrIWidth:=Form1.scrollbar24.SBPosition;
   for f1:=0 to 3 do
      placeIsland(cross[f1],CrIWidth,false,ml);
end;
rpos:=rseed;

if form1.radiobox25.checked then begin
   SPWidth:=Form1.scrollbar20.SBPosition*ml;
   SPStep:=Form1.scrollbar19.SBPosition*ml;
setlength(mask,(SPWidth*2)+1,(SPWidth*2)+1);
for i:=0 to SPWidth do
  for j:=0 to SPWidth do begin
     if ((i*i)+(j*j))<=(SPWidth*SPWidth) then f3:=0 else f3:=1;
     mask[SPWidth-i,SPWidth-j]:=f3;mask[i+SPWidth,SPWidth-j]:=f3;
     mask[SPWidth-i,SPWidth+j]:=f3;mask[i+SPWidth,SPWidth+j]:=f3;
end;
   b1:=0;f1:=Form1.scrollbar21.SBPosition;
   r2:=0;
   f3:=((rmapsize.x*ml)div 2);
   repeat
   inc(f1);if f1>360 then f1:=f1-360;
   r2:=r2+(SPStep / 200);
   r:=((f1*pi)/180);
   i:=trunc(sin(r)*r2)+f3;j:=trunc(cos(r)*r2)+f3;
   placeland(xy(i,j),SPWidth,false,ml);
   if r2>f3 then b1:=1;
   until b1=1;
   SPStart:=Form1.scrollbar18.SBPosition;
for f1:=0 to (SPStart*ml) do
   for f2:=0 to (SPStart*ml) do begin
      mapdata[f1+((rmapsize.x*ml) div 10),f2+((rmapsize.y*ml) div 10)]:=0;
      mapdata[(rmapsize.x*ml)-f1-((rmapsize.x*ml) div 10),(rmapsize.y*ml)-f2-((rmapsize.y*ml) div 10)]:=0;
      mapdata[f1+((rmapsize.x*ml) div 10),(rmapsize.y*ml)-f2-((rmapsize.y*ml) div 10)]:=0;
      mapdata[(rmapsize.x*ml)-f1-((rmapsize.x*ml) div 10),f2+((rmapsize.y*ml) div 10)]:=0;
   end;
end;

if form1.radiobox23.checked then begin
   SwCur:=Form1.scrollbar16.SBPosition;
for f1:=0 to (((rmapsize.x*ml)-1)div 2) do
   for f2:=0 to (((rmapsize.y*ml)-1)div 2) do begin
      f3:=brandom(10);
      for i:=0 to 1 do
         for j:=0 to 1 do begin
      if f3<swcur then mapdata[(f1*2)+i,(f2*2)+j]:=1;
      if f3>swcur then mapdata[(f1*2)+i,(f2*2)+j]:=0;
      if f3=swcur then mapdata[(f1*2)+i,(f2*2)+j]:=2;
      end;
   end;
   SwCur:=Form1.scrollbar17.SBPosition;
for f1:=0 to (SwCur*ml) do
   for f2:=0 to (SwCur*ml) do begin
      mapdata[f1+((rmapsize.x*ml) div 10),f2+((rmapsize.y*ml) div 10)]:=0;
      mapdata[(rmapsize.x*ml)-f1-((rmapsize.x*ml) div 10),(rmapsize.y*ml)-f2-((rmapsize.y*ml) div 10)]:=0;
      mapdata[f1+((rmapsize.x*ml) div 10),(rmapsize.y*ml)-f2-((rmapsize.y*ml) div 10)]:=0;
      mapdata[(rmapsize.x*ml)-f1-((rmapsize.x*ml) div 10),f2+((rmapsize.y*ml) div 10)]:=0;
   end;
flatbeach:=false;
end;

if form1.radiobox22.checked then begin
   chSize:=Form1.scrollbar15.SBPosition;
   i:=trunc((rmapsize.x*ml) / chsize)div 2;
   j:=trunc((rmapsize.y*ml) / chsize)div 2;
   b1:=0;
   for f1:=0 to i do begin
      if b1=0 then b1:=1 else b1:=0;
      b2:=b1;
      for f2:=0 to j do begin
         if b2=0 then b2:=1 else b2:=0;
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)+(f1*chSize*ml),((rmapsize.y*ml)div 2)+(f2*chSize*ml)),chSize*ml,false,ml);
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)-(chSize*ml)-(f1*chSize*ml),((rmapsize.y*ml)div 2)-(chSize*ml)-(f2*chSize*ml)),chSize*ml,false,ml);
      end;
   end;
   b1:=1;
   for f1:=0 to i do begin
      if b1=0 then b1:=1 else b1:=0;
      b2:=b1;
      for f2:=0 to j do begin
         if b2=0 then b2:=1 else b2:=0;
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)-(chSize*ml)-(f1*chSize*ml),((rmapsize.y*ml)div 2)+(f2*chSize*ml)),chSize*ml,false,ml);
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)+(f1*chSize*ml),((rmapsize.y*ml)div 2)-(chSize*ml)-(f2*chSize*ml)),chSize*ml,false,ml);
      end;
   end;
end;

if form1.radiobox21.checked then begin
setlength(mask,(ml*2)+1,(ml*2)+1);
for i:=0 to ml do
  for j:=0 to ml do begin
     if ((i*i)+(j*j))<=(ml*ml) then f3:=0 else f3:=1;
     mask[ml-i,ml-j]:=f3;mask[i+ml,ml-j]:=f3;
     mask[ml-i,ml+j]:=f3;mask[i+ml,ml+j]:=f3;
end;
   iLISize:=Form1.scrollbar11.SBPosition;
   iLICur:=Form1.scrollbar12.SBPosition;
   for f1:=0 to ilICur do
      placeIsland(Ilislands[f1],iLIsize,false,ml);
   iLLSize:=Form1.scrollbar13.SBPosition;
   iLLCur:=Form1.scrollbar14.SBPosition;
   for f1:=0 to ilLCur do
      placeIsland(IlLakes[f1],iLLsize,true,ml);
end;

if form1.radiobox19.checked then begin
setlength(mask,(ml*2)+1,(ml*2)+1);
for i:=0 to ml do
  for j:=0 to ml do begin
     if ((i*i)+(j*j))<=(ml*ml) then f3:=0 else f3:=1;
     mask[ml-i,ml-j]:=f3;mask[i+ml,ml-j]:=f3;
     mask[ml-i,ml+j]:=f3;mask[i+ml,ml+j]:=f3;
end;
   iSize:=Form1.scrollbar9.SBPosition;
   iCur:=Form1.scrollbar10.SBPosition;
   for f1:=0 to iCur do
      placeIsland(islands[f1],isize,false,ml);
end;

if form1.radiobox20.checked then begin
flatbeach:=false;
SWidth:=Form1.scrollbar4.SBPosition*ml;
BSize:=Form1.scrollbar4.SBPosition*ml;
BCur:=Form1.scrollbar5.SBPosition;
r:=(bCur*(rmapsize.x*ml)/10);
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to BCur do begin
i:=((rmapsize.x*ml)div 2)+trunc(Billiard[f1].x*bSize/5);
j:=((rmapsize.y*ml)div 2)+trunc(Billiard[f1].y*bSize/5);
if (i>=Bsize)and(j>=Bsize)and(i<=(rmapsize.x*ml)-Bsize)and(j<=(rmapsize.y*ml)-Bsize) then
    placeland(xy(i,j),Swidth,false,ml);
end;
end;

if form1.radiobox18.checked then begin
SWidth:=Form1.scrollbar8.SBPosition*ml;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to SCur do begin
   for f2:=0 to SLength do begin
      placeland(xy(Stripes[f1].length[f2].pos.x*ml,Stripes[f1].length[f2].pos.y*ml),Swidth,false,ml);
   end;
end;
Swidth:=6;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to SCur do begin
   for f2:=0 to SLength do begin
      for f3:=0 to high(Stripes[f1].length[f2].length) do begin
         if f3<=Form1.scrollbar8.SBPosition then
      placeland(xy(Stripes[f1].length[f2].pos.x*ml,Stripes[f1].length[f2].pos.y*ml),Swidth,false,ml);

      end;
   end;
end;
end;

if flatbeach then begin
for f1:=1 to (rmapsize.x*ml)-1 do
   for f2:=1 to (rmapsize.y*ml)-1 do begin
      f3:=0;
      if mapdata[f1,f2]=1 then begin
         for i:=-1 to 1 do
         for j:=-1 to 1 do begin
            if mapdata[f1+i,f2+j]=0 then inc(f3);
         end;
         if f3>0 then begin
           if brandom(6)=0 then begin
              for i:=-1 to 1 do
              for j:=-1 to 1 do begin
                 mapdata[f1+i,f2+j]:=6;
              end;
           end;
         end;
      end;
end;
for f1:=1 to (rmapsize.x*ml)-1 do
   for f2:=1 to (rmapsize.y*ml)-1 do begin
      if mapdata[f1,f2]=6 then mapdata[f1,f2]:=0;
end;
end;

if Form1.Check22.Checked then begin
if form1.CheckBox3.checked then begin
f4:=-1;
for f1:=0 to hcount do begin
    if trunc(ml*(handw[f1]/10))<>f4 then begin
    f4:=trunc(ml*(handw[f1]/10));if f4<1 then f4:=1;
SWidth:=2*f4;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
    end;
    placeland(xy((handpos[f1].X*ml)+(ml),(handpos[f1].Y*ml)+(ml)),Swidth,handmp[f1]=1,ml);
end;
end;
end;

if form1.radiobox3.checked then begin
   for f1:=0 to ((rmapsize.x*ml) div 2) do
      for f2:=0 to (rmapsize.y*ml) do
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[f1,f2];
end;
if form1.radiobox4.checked then begin
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to ((rmapsize.y*ml) div 2) do
         mapdata[f1,(rmapsize.y*ml)-f2]:=mapdata[f1,f2];
end;
if form1.radiobox5.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be used only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[f1,f2]:=mapdata[f2,f1];
end;
if form1.radiobox6.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be used only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[(rmapsize.x*ml)-f2,f1];
end;
if form1.radiobox11.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be used only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[f1,f2]:=mapdata[f2,f1];
   for f1:=0 to ((rmapsize.x*ml) div 2) do
      for f2:=0 to ((rmapsize.y*ml) div 2) do begin
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[f1,f2];
         mapdata[f1,(rmapsize.y*ml)-f2]:=mapdata[f1,f2];
         mapdata[(rmapsize.x*ml)-f1,(rmapsize.y*ml)-f2]:=mapdata[f1,f2];
   end;
end;
if form1.radiobox12.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be used only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[(rmapsize.x*ml)-f2,f1];
   for f1:=0 to ((rmapsize.x*ml) div 2) do
      for f2:=0 to ((rmapsize.y*ml) div 2) do begin
         mapdata[f1,f2]:=mapdata[(rmapsize.x*ml)-f1,f2];
         mapdata[f1,(rmapsize.y*ml)-f2]:=mapdata[(rmapsize.x*ml)-f1,f2];
         mapdata[(rmapsize.x*ml)-f1,(rmapsize.y*ml)-f2]:=mapdata[(rmapsize.x*ml)-f1,f2];
   end;
end;

if Form1.Check22.Checked=false then begin
if form1.CheckBox3.checked then begin
f4:=-1;
for f1:=0 to hcount do begin
    if trunc(ml*(handw[f1]/10))<>f4 then begin
    f4:=trunc(ml*(handw[f1]/10));if f4<1 then f4:=1;
SWidth:=2*f4;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
    end;
    placeland(xy((handpos[f1].X*ml)+(ml),(handpos[f1].Y*ml)+(ml)),Swidth,handmp[f1]=1,ml);
end;
end;
end;

if ml>1 then begin
if lowquality then begin
   for f1:=0 to ((rmapsize.x*ml) div 4)-1 do
   for f2:=0 to ((rmapsize.y*ml) div 4)-1 do begin
      for i:=0 to 3 do
         for j:=0 to 3 do
            mapdata[(f1*4)+i,(f2*4)+j]:=mapdata[f1*4,f2*4];
   end;
end;
if Ulowquality then begin
   for f1:=0 to ((rmapsize.x*ml) div 8)-1 do
   for f2:=0 to ((rmapsize.y*ml) div 8)-1 do begin
      for i:=0 to 7 do
         for j:=0 to 7 do
            mapdata[(f1*8)+i,(f2*8)+j]:=mapdata[f1*8,f2*8];
   end;
end;
end;
if form1.CheckBox21.Checked then begin
   for f1:=0 to ((rmapsize.x*ml) ) do
      for f2:=0 to ((rmapsize.y*ml)) do
         if mapdata[f1,f2]=1 then mapdata[f1,f2]:=0 else  mapdata[f1,f2]:=1;
end;
end;

procedure TMapGenerator.generatepreviewdata;
var f1,f2,dx,dy,n,ddx,ddy:integer; 
var stps:TXY;
var ok:boolean;
var a:single;
begin
if usepreset=false then rseed:=brandomize;

scount:=Form1.scrollbar6.SBMax;
setlength(stripes,scount+1);
SLengthMax:=Form1.scrollbar7.SBMax;
SLength:=Form1.scrollbar7.SBPosition;
SWidth:=Form1.scrollbar8.SBMax;
mapsize.x:=str2int(wrt(form1.editbox17.Text));
mapsize.y:=str2int(wrt(form1.editbox18.Text));
rmapsize.x:=(mapsize.x+2);
rmapsize.y:=(mapsize.y+2);

rpos:=rseed;

n:=0;
stps:=xy(brandom(rmapsize.X+1),brandom(rmapsize.Y+1));
for f1:=0 to scount do begin  inc(n);
if n>10 then begin n:=0;stps:=xy(brandom(rmapsize.X+1),brandom(rmapsize.Y+1));
end;
   stripes[f1].startpos:=stps;
   setlength(stripes[f1].length,SlengthMAX+1);

   Stripes[f1].length[0].pos:=XY(stripes[f1].startpos.X+brandom(5)-3,stripes[f1].startpos.Y+brandom(5)-3);
      dx:=brandom(7)-3;
      dy:=brandom(7)-3;
   for f2:=1 to SlengthMAX do begin
      dx:=dx+brandom(3)-1;if dx>5 then dx:=5;if dx<-5 then dx:=-5;
      dy:=dy+brandom(3)-1;if dy>5 then dy:=5;if dy<-5 then dy:=-5;
      Stripes[f1].length[f2].pos:=XY(stripes[f1].length[f2-1].pos.X+dx,stripes[f1].length[f2-1].pos.Y+dy);

      setlength(Stripes[f1].length[f2].length,1);
      ddx:=brandom(7)-3;
      ddy:=brandom(7)-3;
      Stripes[f1].length[f2].length[0]:=XY(Stripes[f1].length[f2].pos.x+ddx,Stripes[f1].length[f2].pos.y+ddy);
   end;
end;

rpos:=rseed;

CrLength:=Form1.scrollbar22.SBMax;
setlength(Cross, CrLength+5);
Cross[0].pos:=XY(rmapsize.x div 5,rmapsize.y div 5);
Cross[1].pos:=XY(rmapsize.x-(rmapsize.x div 5),rmapsize.y div 5);
Cross[2].pos:=XY(rmapsize.x div 5,rmapsize.y -(rmapsize.y div 5));
Cross[3].pos:=XY(rmapsize.x-(rmapsize.x div 5),rmapsize.y -(rmapsize.y div 5));
for f1:=0 to (crlength div 4) do begin
   f2:=(f1*4)+4;if f2<(CrLength+5)then Cross[f2].pos:=XY((rmapsize.x div 2)-(f1*(rmapsize.x div 14)),rmapsize.y div 2);
   f2:=(f1*4)+5;if f2<(CrLength+5)then Cross[f2].pos:=XY((rmapsize.x div 2),(rmapsize.y div 2)-(f1*(rmapsize.y div 14)));
   f2:=(f1*4)+6;if f2<(CrLength+5)then Cross[f2].pos:=XY((rmapsize.x div 2)+(f1*(rmapsize.x div 14)),rmapsize.y div 2);
   f2:=(f1*4)+7;if f2<(CrLength+5)then Cross[f2].pos:=XY((rmapsize.x div 2),(rmapsize.y div 2)+(f1*(rmapsize.y div 14)));
end;dx:=70;
for f1:=0 to CrLength+4 do begin
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   Cross[f1].r[f2]:=dx;
end;
end;

rpos:=rseed;

ilICount:=Form1.scrollbar12.SBMax;
ilLCount:=Form1.scrollbar14.SBMax;
setlength(iLislands, ilICount+1);
setlength(iLlakes, ilLCount+1);
dx:=100;
for f1:=0 to ilIcount do begin
iLislands[f1].pos:=XY(brandom(rmapsize.x+1),brandom(rmapsize.y+1));
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   iLislands[f1].r[f2]:=dx;
end;
end;
dx:=100;
for f1:=0 to ilLcount do begin
iLlakes[f1].pos:=XY(brandom(rmapsize.x+1),brandom(rmapsize.y+1));
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   iLlakes[f1].r[f2]:=dx;
end;
end;

rpos:=rseed;

iCount:=Form1.scrollbar10.SBMax;
setlength(islands, iCount+1);
dx:=100;
for f1:=0 to icount do begin
islands[f1].pos:=XY(brandom(rmapsize.x+1),brandom(rmapsize.y+1));
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   islands[f1].r[f2]:=dx;
end;
end;

rpos:=rseed;

BCount:=Form1.scrollbar5.SBMax;
setlength(billiard, bCount+1);
Bcur:=1;
billiard[0]:=xy(0,0);
f1:=2;
a:=0;
repeat
ok:=false;
a:=a+(5*pi/180);
if a>(2*pi) then begin a:=a-(2*pi);f1:=f1+2;end;
dx:=trunc(sin(a)*f1);dy:=trunc(cos(a)*f1);
ddx:=0;
for f2:=0 to Bcur-1 do begin
   if sqrt(((dx-billiard[f2].x)*(dx-billiard[f2].x))+((dy-billiard[f2].y)*(dy-billiard[f2].y)))<10 then ddx:=1;
end;
if ddx=0 then begin
   billiard[Bcur]:=xy(dx,dy);inc(Bcur);
end;
if Bcur>=Bcount then ok:=true;
until ok;
for f1:=1 to BCount do begin
   stps:=billiard[f1];
   f2:=brandom(Bcount)+1;
   billiard[f1]:=billiard[f2];billiard[f2]:=stps;
end;
generatepreview;
end;
function TMapGenerator.getpreviewbitmap: Pbitmap;
var stream:Pstream;
begin
if preview=nil then preview:=NewBitmap(mapsize.x,mapsize.Y);
stream:=NewMemoryStream;
savePrewiveBitmaptostream(stream,gml);
stream.Position:=0;
preview.LoadFromStream(stream);
stream.Free;
result:=preview;
end;

function TMapGenerator.getreadyminimapbitmap: Pbitmap;
var stream:Pstream;
begin
if preview<>nil then preview.Free;
preview:=NewBitmap(mapsize.x,mapsize.Y);
stream:=NewMemoryStream;
saveReadyMinimaptostream(stream);
stream.Position:=0;
preview.LoadFromStream(stream);
stream.Free;
result:=preview;
end;

procedure TMapGenerator.LoadBMGFile(dir, fname: string);
var f:Pstream;
var f1,f2:integer;
begin
   f:=NewReadFileStream(dir+fname);
   f.Read(mapitemscount,sizeof(mapitemscount));
   setlength(mapitems,mapitemscount+1);
   for f1:=0 to mapitemscount do begin
      f.Read(mapitems[f1].msk,sizeof(mapitems[f1].msk));
      f.Read(mapitems[f1].pass,sizeof(mapitems[f1].pass));
   end;
   f.Read(mapsize.x,sizeof(mapsize.x));
   f.Read(mapsize.y,sizeof(mapsize.y));
   setlength(readymapdata,mapsize.x+1,mapsize.y+1);
   setlength(readyminimap,mapsize.x+1,mapsize.y+1);
   for f1:=0 to mapsize.x-1 do
      for f2:=0 to mapsize.y-1 do begin
         f.Read(readymapdata[f1,f2],2);
         f.Read(readyminimap[f1,f2],1);
      end;
   f.Read(placedobtaclescount,sizeof(placedobtaclescount));
   setlength(placedobtacles,placedobtaclescount+1);
   for f1:=0 to placedobtaclescount do begin
      placedobtacles[f1].pos:=Stream2XY(f);
      f.Read(placedobtacles[f1].ID,sizeof(placedobtacles[f1].ID));
   end;
   if tileset<>nil then tileset.free;
      tileset:=TBMGSpriteCollection.create;
      tileset.loadfromstream(f);
   mpalette:=tileset.Mpalette;
   f.free;
   end;

procedure TMapGenerator.placeland(pos: txy; radius: word;invert:boolean;ml:byte);
var f1,f2,f3:integer;
begin
for f1:=pos.x-radius to pos.x+radius do
   for f2:=pos.Y-radius to pos.y+radius do begin
      if f1>=0 then
      if f2>=0 then
      if f1<=(rmapsize.X*ml) then
      if f2<=(rmapsize.Y*ml) then begin
         if mapdata[f1,f2]=1 then begin
            mapdata[f1,f2]:=mask[f1-pos.x+radius,f2-pos.Y+radius];
         end;
         if (invert) then begin
            f3:=mask[f1-pos.x+radius,f2-pos.Y+radius];
            if f3=0 then begin f3:=1;
            mapdata[f1,f2]:=f3;end;
         end;
      end;
end;
end;

procedure TMapGenerator.placeobtacle(pos: Txy; radius: word;
  obID: integer;checkfor:boolean;addnew:boolean);
var f1,f2,f3,x,y,ok,rcur,i,j:integer;
begin
if tileset=nil then exit;
if tileset.Obtaclescount<0 then exit;
if obID=-1 then obID:=random(tileset.obtaclescount+1);
for rcur:=0 to radius do begin
for f1:=pos.x-rcur to pos.x+rcur do
   for f2:=pos.y-rcur to pos.y+rcur do begin
      ok:=0;
      for f3:=0 to tileset.Obtacles[obID].itemcount do begin
         x:=f1+tileset.Obtacles[obID].itempos[f3].Y;
         y:=f2+tileset.Obtacles[obID].itempos[f3].X;
         if (ok=0)and(x>=0)and(y>=0)and(x<mapsize.x)and(y<mapsize.y)then begin
            if mapitems[readymapdata[x,y]].pass<>0 then ok:=1;

            for i:=0 to 15 do
              for j:=0 to 15 do
                if mapitems[readymapdata[x,y]].msk[i,j]<>0 then ok:=1;
         end else begin
            if f3=1 then ok:=1;
         end;
      end;
      if checkfor=false then ok:=0;
      if ok=0 then begin
         for f3:=0 to tileset.Obtacles[obID].itemcount do begin
            x:=f1+tileset.Obtacles[obID].itempos[f3].Y;
            y:=f2+tileset.Obtacles[obID].itempos[f3].X;
            if (x>=0)and(y>=0)and(x<mapsize.x)and(y<mapsize.y)then begin
               if ((checkfor=false)and(addnew=false)) then begin
                   mapitems[readymapdata[x,y]].spr:=tileset.Obtacles[obID].items[f3];
                   mapitems[readymapdata[x,y]].pass:=tileset.Obtacles[obID].items[f3].pass;
               end else begin
                   readymapdata[x,y]:=addmapitem(tileset.Obtacles[obID].items[f3]);
               end;
            end;
         end;
   inc(placedobtaclescount);
   setlength(placedobtacles,placedobtaclescount+1);
   placedobtacles[placedobtaclescount].pos:=xy(f1,f2);
   placedobtacles[placedobtaclescount].id:=obID;
         exit;
      end;
   end;
end;
end;

procedure TMapGenerator.placeIsland(island:tislands; radius: word;
  invert: boolean;ml:byte);
var f1,f2,dx,dy:integer; 
var a:single;
begin

for f1:=0 to 360 do begin
a:=(f1*pi/180);

for f2:=0 to trunc(island.r[f1]*radius/100) do begin
   dx:=(island.pos.x*ml)+trunc(sin(a)*f2*ml);
   dy:=(island.pos.y*ml)+trunc(cos(a)*f2*ml);
   placeland(xy(dx,dy),ml,invert,ml)

end;
end;
end;

procedure TMapGenerator.saveBMGFile(dir, fname: string);
var f:Pstream;
var f1,f2:integer;
begin
   f:=NewMemoryStream;
   f.Write(mapitemscount,sizeof(mapitemscount));
   for f1:=0 to mapitemscount do begin
      f.Write(mapitems[f1].msk,sizeof(mapitems[f1].msk));
      f.Write(mapitems[f1].pass,sizeof(mapitems[f1].pass));
   end;
   f.Write(mapsize.x,sizeof(mapsize.x));
   f.Write(mapsize.y,sizeof(mapsize.y));
   for f1:=0 to mapsize.x-1 do
      for f2:=0 to mapsize.y-1 do begin
         f.Write(readymapdata[f1,f2],2);
         f.Write(readyminimap[f1,f2],1);
      end;
   f.Write(placedobtaclescount,sizeof(placedobtaclescount));
   for f1:=0 to placedobtaclescount do begin
      XY2Stream(placedobtacles[f1].pos,f);
      f.Write(placedobtacles[f1].ID,sizeof(placedobtacles[f1].ID));
   end;
   if tileset=nil then begin
      spritebases.current.savetostream(f);
   end else begin
      tileset.savetostream(f);
   end;
   f.SaveToFile(dir+fname+'.bmg',0,f.Position);
   f.free;
end;

procedure TMapGenerator.savePrewiveBitmaptostream(strm: PStream;ml:byte);
var w,h,f1,f2,f3:integer;
var bh:bmHeader;
var csh:array [0..249]of byte;
var cshpz:byte;
var cllr:array[0..4]of byte;
begin
w:=mapsize.x * ml;h:=mapsize.Y * ml;
if SpriteBases=nil then exit;
if SpriteBases.current=nil then exit;
if tilesetcolor then begin
if SpriteBases.current.LandItemsCount>=0 then begin
   f1:=0;
   if SpriteBases.current.LandItems[f1].kind=1 then cllr[0]:=SpriteBases.current.LandItems[f1].Bitmap.data[32,32];
   if SpriteBases.current.LandItems[f1].kind=2 then cllr[0]:=SpriteBases.current.LandItems[f1].colID[1];
end;
if SpriteBases.current.WaterItemsCount>=0 then begin
   f1:=0;
   if SpriteBases.current.WaterItems[f1].kind=1 then cllr[1]:=SpriteBases.current.WaterItems[f1].Bitmap.data[32,32];
   if SpriteBases.current.WaterItems[f1].kind=2 then cllr[1]:=SpriteBases.current.WaterItems[f1].colID[1];
end;
if SpriteBases.current.BeachItemsCount>=0 then begin
   if SpriteBases.current.BeachItems[0].kind=1 then cllr[2]:=SpriteBases.current.BeachItems[0].Bitmap.data[32,32];
   if SpriteBases.current.BeachItems[0].kind=2 then cllr[2]:=SpriteBases.current.BeachItems[0].colID[1];
end else cllr[2]:=cllr[0];
if SpriteBases.current.BeachItemsCount>=1 then begin
   if SpriteBases.current.BeachItems[1].kind=1 then cllr[3]:=SpriteBases.current.BeachItems[1].Bitmap.data[32,32];
   if SpriteBases.current.BeachItems[1].kind=2 then cllr[3]:=SpriteBases.current.BeachItems[1].colID[1];
end else cllr[3]:=cllr[1];
end else begin
cllr[0]:=0;
cllr[1]:=1;
cllr[2]:=2;
cllr[3]:=3;
end;
bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;
bh.f.Size:=(w*h*4)+1078;
bh.i.Widt:=w*2;bh.i.Heig:=h*2;
bh.i.SizI:=(w*h*4);
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
bh.p:=SpriteBases.current.Mpalette;
if tilesetcolor=false then begin
bh.p[0].rgb.rgbBlue:=50;bh.p[0].rgb.rgbRed:=50;bh.p[0].rgb.rgbGreen:=150;
bh.p[1].rgb.rgbBlue:=200;bh.p[1].rgb.rgbRed:=80;bh.p[1].rgb.rgbGreen:=80;
bh.p[2].rgb.rgbBlue:=100;bh.p[2].rgb.rgbRed:=100;bh.p[2].rgb.rgbGreen:=100;
bh.p[3].rgb.rgbBlue:=50;bh.p[3].rgb.rgbRed:=50;bh.p[3].rgb.rgbGreen:=50;
end;
strm.Write(bh.f.Typf,2);strm.Write(bh.f.Size,4);strm.Write(bh.f.Res1,2);strm.Write(bh.f.Res2,2);strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);strm.Write(bh.i.Widt,4);strm.Write(bh.i.Heig,4);strm.Write(bh.i.Plan,2);strm.Write(bh.i.BitC,2);strm.Write(bh.i.Comp,4);strm.Write(bh.i.SizI,4);strm.Write(bh.i.XppM,4);strm.Write(bh.i.YppM,4);strm.Write(bh.i.NCoL,4);strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
cshpz:=0;
for f2:=(h) downto 1 do
   for f3:=0 to 1 do
   for f1:=1 to (w) do begin
      csh[cshpz]:=cllr[mapdata[(f1+1),(f2+1)]];inc(cshpz);
      csh[cshpz]:=cllr[mapdata[(f1+1),(f2+1)]];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         strm.write(csh,250);
      end;
   end;
if cshpz>0 then strm.write(csh,cshpz+1);

end;

procedure TMapGenerator.saveReadyMinimaptostream(strm: PStream);
var w,h,f1,f2:integer;
var bh:bmHeader;
var csh:array [0..249]of byte;
var cshpz:byte;

begin
w:=mapsize.x;h:=mapsize.Y;

bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;
bh.f.Size:=(w*h)+1078;
bh.i.Widt:=w;bh.i.Heig:=h;
bh.i.SizI:=(w*h);
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
bh.p:=Mpalette;
strm.Write(bh.f.Typf,2);strm.Write(bh.f.Size,4);strm.Write(bh.f.Res1,2);strm.Write(bh.f.Res2,2);strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);strm.Write(bh.i.Widt,4);strm.Write(bh.i.Heig,4);strm.Write(bh.i.Plan,2);strm.Write(bh.i.BitC,2);strm.Write(bh.i.Comp,4);strm.Write(bh.i.SizI,4);strm.Write(bh.i.XppM,4);strm.Write(bh.i.YppM,4);strm.Write(bh.i.NCoL,4);strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
cshpz:=0;
for f2:=(h-1) downto 0 do
   for f1:=0 to (w-1) do begin
      csh[cshpz]:=readyminimap[f2,f1];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         strm.write(csh,250);
      end;
   end;
if cshpz>0 then strm.write(csh,cshpz+1);

end;

procedure TMapGenerator.savetomaxmap;
var f1,f2:integer;
begin
for f1:=0 to 111 do
   for f2:=0 to 111 do begin
     maxmap.Data.map[f1,f2].idword:=readymapdata[f1,f2];
     maxmap.map[f2,f1].idword:=readymapdata[f1,f2];
     maxmap.Data.minimap[f1,f2]:=readyminimap[f1,f2];
   end;
maxmap.Data.mapsize:=mapsize.arr;
maxmap.Data.mapitemscount:=mapitemscount+1;
setlength(maxmap.Data.bitmaps,mapitemscount+1);
setlength(maxmap.Data.passtab,mapitemscount+1);
for f1:=0 to mapitemscount do begin
   maxmap.Data.bitmaps[f1]:=mapitems[f1].spr;
   maxmap.Data.passtab[f1]:=mapitems[f1].pass;
end;
maxmap.Data.Mpalette:=Mpalette;
maxmap.loaded:=true;

end;

procedure TMapGenerator.placesqrland(pos: txy; size: word;
  invert: boolean;ml:byte);
var f1,f2,dx,dy:integer;
begin
for f1:=0 to size do
for f2:=0 to size do begin
   dx:=pos.x+f1;
   dy:=pos.y+f2;
   if dx>=0 then
   if dy>=0 then
   if dx<=(rmapsize.X*ml) then
   if dy<=(rmapsize.Y*ml) then begin
      if (invert) then begin if mapdata[dx,dy]=0 then mapdata[dx,dy]:=1 end;
      if (invert=false) then begin if mapdata[dx,dy]=1 then mapdata[dx,dy]:=0;end;
   end;
end;
end;

procedure TMapGenerator.mapchange(before, after,ml: byte);
var f1,f2:integer;
begin
for f1:=0 to (rmapsize.x*ml) do
   for f2:=0 to (rmapsize.y*ml) do
      if mapdata[f1,f2]=before then mapdata[f1,f2]:=after;
end;

procedure TMapGenerator.mapchange(cur, findqty, find, setto1, setto2,
  ml: byte);
var k,l,c:byte;
var f1,f2:integer;
begin
for f1:=1 to (rmapsize.x*ml)-1 do
   for f2:=1 to (rmapsize.y*ml)-1 do begin
     if mapdata[f1,f2]=cur then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
            if mapdata[f1+k-1,f2+l-1]=find then inc(c);
      if findqty<=c then if random(2)=1 then mapdata[f1,f2]:=setto1 else mapdata[f1,f2]:=setto2;
   end;
end;
end;

function TMapGenerator.itemID(msk: tgenIN): integer;
var f1,f2,f3,f5:integer;
var ok,ok2:boolean;
begin
result:=-1;
for f1:=0 to mapitemscount do begin
   f5:=0;
   f2:=0;ok:=false;
   repeat
     f3:=0;ok2:=false;
     repeat
        if mapitems[f1].msk[f2,f3]<>msk[f2,f3] then f5:=1;
        inc(f3);
        if f5=1 then ok2:=true;
        if f3>15 then ok2:=true;
     until ok2;
     inc(f2);
     if f5=1 then ok:=true;
     if f2>15 then ok:=true;
   until ok;
   if f5=0 then begin
      inc(mapitemsQTY[f1]);
      result:=f1;exit;
   end;
end;

if cacheloaded then begin
   inc(logIcheck);
   for f1:=0 to cachecount do begin
   f5:=0;
   f2:=0;ok:=false;
   repeat
     f3:=0;ok2:=false;
     repeat
        if cache[f1].msk[f2,f3]<>msk[f2,f3] then f5:=1;
        inc(f3);
        if f5=1 then ok2:=true;
        if f3>15 then ok2:=true;
     until ok2;
     inc(f2);
     if f5=1 then ok:=true;
     if f2>15 then ok:=true;
   until ok;
   if f5=0 then begin
      inc(logIfound);
      result:=addmapitem(f1);
      exit;
   end;
  end;
end;

end;

procedure TMapGenerator.loadcache;
var ss:string;
var P:Pstream; 
var f1:integer;

var Fs:TBitmaps;
begin

fs.allowAnim:=0;
   logIread:=0;   logIcheck:=0;   logIfound:=0;   logIwrite:=0;
   cachecount:=-1;
   for f1:=0 to high(cache) do setlength(cache[f1].SFinal,0);
   setlength(cache,0);
   cacheloaded:=false;

   ss:=getstartdir+'GenCache.res';
   if fileexists(ss) then begin
      p:=NewReadFileStream(ss);
      p.Seek(0,spBegin);
      p.Read(cachecount,sizeof(cachecount));
      setlength(cache,cachecount+1);logIread:=cachecount+1;
      for f1:=0 to cachecount do begin
         setlength(cache[f1].SFinal,0);
         p.Read(cache[f1].msk,256);
         cache[f1].PosInFile:=p.Position;
         cfsize:=cache[f1].PosInFile+sizeof(fs);
         p.Seek(p.Position+sizeof(fs),spBegin);

      end;
      p.Free;
      cacheloaded:=true;
   end;

end;

function TMapGenerator.addmapitem(cacheID: integer): word;
var p:Pstream;
var ss:string;
begin
if high(cache[cacheid].SFinal)<0 then begin
   ss:=getstartdir+'GenCache.res';
   if fileexists(ss) then begin
      p:=NewReadFileStream(ss);
         p.Seek(cache[cacheId].PosInFile,spBegin);
         setlength(cache[cacheid].SFinal,1);
         p.Read(cache[cacheid].SFinal[0],sizeof(cache[cacheid].SFinal[0]));

      p.free;
   end;
end;

inc(mapitemscount);
setlength(mapitems,mapitemscount+1);
setlength(mapitemsQTY,mapitemscount+1);
mapitemsQTY[mapitemscount]:=0;
mapitems[mapitemscount].msk:=cache[cacheid].msk;
mapitems[mapitemscount].Sfinal:=cache[cacheid].Sfinal[0];
mapitems[mapitemscount].spr:=tileset.getsprite(cache[cacheid].SFinal[0]);
mapitems[mapitemscount].pass:=cache[cacheid].SFinal[0].pass;

result:=mapitemscount;

end;

function TMapGenerator.addmapitem(msk: tgenIN; sfinal: TBitmaps): integer;
begin
inc(mapitemscount);
setlength(mapitems,mapitemscount+1);
setlength(mapitemsQTY,mapitemscount+1);
mapitemsQTY[mapitemscount]:=0;
mapitems[mapitemscount].msk:=msk;
mapitems[mapitemscount].spr:=tileset.getsprite(sfinal);
mapitems[mapitemscount].sFinal:=sfinal;
mapitems[mapitemscount].pass:=sfinal.pass;
mapitems[mapitemscount].spr.pass:=sfinal.pass;

result:=mapitemscount;
end;

procedure TMapGenerator.savetoMMmap(percTo:Pcontrol;fname:string;hq:boolean;animwater:boolean;hqanim:boolean;useMMwaterOnly:byte);
var f:PIniFile;
var terpath,mappath,hdr,TilName,fns:string;
var Sfiles:PDirList;
var p:Pstream;
var f1,f2,f3,fn:integer;
var tset:TBMGSpriteCollection;
function CheckSfinal(one,two:TBitmaps):boolean;
var q,w:integer;
var okk,okk2:boolean;
begin
result:=false;
   q:=0;okk:=false;
   repeat
     w:=0;okk2:=false;
     repeat
        if one.data[q,w]<>two.data[q,w] then exit;
        inc(w);
        if w>63 then okk2:=true;
     until okk2;
     inc(q);
     if q>63 then okk:=true;
   until okk;
result:=true;
end;
function CheckMSK(mitm:genmapitem):integer;
var i,j,k,l:integer;
var ok,ok2:boolean;
begin
result:=-1;
   for i:=0 to cachecount do
      if cache[i].PosInFile=1 then
         if cache[i].TilesetName=tilname then
           if cache[i].SFinal[0].idInTileset=mitm.sfinal.idInTileset then
             if cache[i].hq=hq then
               if cache[i].animwater=animwater then
                 if cache[i].hqanim=hqanim then
   begin
   l:=0;  
   j:=0;ok:=false;
   repeat
     k:=0;ok2:=false;
     repeat
        if cache[i].msk[j,k]<>mitm.msk[j,k] then l:=1;
        inc(k);
        if l=1 then ok2:=true;
        if k>15 then ok2:=true;
     until ok2;
     inc(j);
     if l=1 then ok:=true;
     if j>15 then ok:=true;
   until ok;
   if l=0 then begin
      if CheckSfinal(cache[i].Sfinal[0],mitm.sfinal) then begin
         result:=f1;exit;
      end;
   end;
   end;
end;
function defaultwaterID:integer;
var i:byte;
begin
result:=-1;
   for i:=0 to mapitemscount do begin
      if mapitems[i].sfinal.purewater=1 then begin
         result:=i;exit;
      end;
   end;
end;
function waterIDinCache:integer;
var i:byte;
begin
result:=-1;
 for i:=0 to cachecount do begin
   if cache[i].PosInFile=1 then
      if cache[i].sfinal[0].purewater=1 then
         if cache[i].TilesetName=tilname then
            begin
               result:=i;exit;
            end;
   end;
end;
begin
fn:=0;
if tileset=nil then begin
   if SpriteBases=nil then exit;
   if SpriteBases.current=nil then exit;
   tset:=SpriteBases.current;
end else begin tset:=tileset;end;
   if mapitemscount>1000 then begin
     if ShowQuestion('Warning!'+#13#10+'Map file is BERY BIG. MM''s MAX clone may crush when process it.(And this mapgenerator too).Make sure to backup original game files!.'+#13#10+
                  'I recommend you to regenerate this map with decreased beachline quality.'+#13#10+#13#10+
                  'Proceed creating map?',
                  'Yes i want to make this map/No.(Strongly recommended)')=2 then exit;
   end else
   if mapitemscount>500 then begin
     if ShowQuestion('Attention!'+#13#10+'Map file is big. MM''s MAX clone may be unstable when process it. Make sure to backup original game files!.'+#13#10+'Proceed creating map?',
                  'Yes make map/No. Stop')=2 then exit;
   end;
   generator.mpalette:=tset.Mpalette;
   if percto<>nil then PercTo.Caption:='Saving MM...';
   tilname:=tset.name;
   f:=OpenIniFile(getstartdir+'max.ini');
   f.Mode:=ifmRead;
   f.Section:='max';
   terpath:=f.ValueString('terrain','');
   f.Free;
   terpath:=getstartdir+terpath;
   terpath:=IncludeTrailingPathDelimiter(terpath);
   if not(directoryExists(terpath+'tmp'))then createdir(terpath+'tmp');
   DeleteFiles(terpath+'tmp\*.*');
   copyfile(PChar(terpath+'terrain.ini'),PChar(terpath+'tmp\terrain.ini'),false);
   Sfiles:=NewDirList(terpath,'*.sps',FILE_ATTRIBUTE_NORMAL);
   cachecount:=-1;
   for f1:=0 to high(cache) do setlength(cache[f1].SFinal,0);
   setlength(cache,0);
   cacheloaded:=false;
   if Sfiles.Count>0 then begin
     cachecount:=Sfiles.Count-1;
     setlength(cache,cachecount+1);
     for f1:=0 to Sfiles.count-1 do begin
         p:=NewReadFileStream(terpath+Sfiles.Names[f1]);
         hdr:=p.ReadStrZ;cache[f1].PosInFile:=0;
         if hdr='BrSp' then begin
            cache[f1].PosInFile:=1;
            p.Read(cache[f1].msk,256);
            setlength(cache[f1].SFinal,1);
            p.Read(cache[f1].SFinal[0],sizeof(cache[f1].SFinal[0]));
            cache[f1].TilesetName:=p.ReadStrZ;
            p.Read(cache[f1].hq,sizeof(cache[f1].hq));
            p.Read(cache[f1].animwater,sizeof(cache[f1].animwater));
            p.Read(cache[f1].hqanim,sizeof(cache[f1].hqanim));
         end;
         p.Free;
     end;
   end;
   f:=OpenIniFile(terpath+'tmp\terrain.ini');
   f.Mode:=ifmWrite;
   for f1:=0 to mapitemscount do begin
      if percto<>nil then begin PercTo.Caption:='Saving MM...'+int2str(trunc((f1 /mapitemscount)*100))+' %' ;applet.ProcessMessages;end;
      f2:=CheckMSK(mapitems[f1]);
      if f2>=0 then begin
         mapitems[f1].mmFileName:=ExtractFileNameWOExt(Sfiles.Names[f2]);
      end else begin
         repeat
           inc(fn);fns:='Brlg';
           if fn<1000 then fns:=fns+'0';
           if fn<100 then fns:=fns+'0';
           if fn<10 then fns:=fns+'0';
           fns:=fns+int2str(fn);
         until not(fileexists(terpath+fns+'.pcx'));
         generator.load(mapitems[f1].spr);
         generator.mpalette:=tset.Mpalette;

         if hq=false then begin
         if mapitems[f1].SFinal.pureWater>=2 then begin
         mapitems[f1].spr:=tset.getsprite(mapitems[f1].SFinal,1,10);
         generator.load(mapitems[f1].spr);

            generator.mpalette[10].rgb.rgbBlue:=255;
            generator.mpalette[10].rgb.rgbGreen:=0;
            generator.mpalette[10].rgb.rgbRed:=255;
         end;

         end;
         p:=NewMemoryStream;
         if hq=false then begin
         if mapitems[f1].SFinal.pureWater=1
            then begin
               if (mapitems[f1].sfinal.allowAnim=1)and(animwater)
                  then generator.saveAnimatedWaterSpriteToStreamAsPCX(p,2,hqanim)
                  else generator.saveSpriteToStreamAsPCX(p,2);
            end else generator.saveSpriteToStreamAsPCX(p,2);
         end;
         if hq then begin
         if mapitems[f1].SFinal.pureWater>=1
            then begin
               if (mapitems[f1].sfinal.allowAnim=1)and(animwater)
                  then generator.saveAnimatedWaterSpriteToStreamAsPCX(p,2,hqanim)
                  else generator.saveSpriteToStreamAsPCX(p,2);
            end else generator.saveSpriteToStreamAsPCX(p,2);
         end; 
         p.savetofile(terpath+'tmp\'+fns+'.pcx',0,p.position);
         p.Free;
         applet.processmessages;
         p:=NewMemoryStream;
         p.WriteStrZ('BrSp');
            p.Write(mapitems[f1].msk,256);
            p.Write(mapitems[f1].SFinal,sizeof(mapitems[f1].SFinal));
            p.WriteStrZ(TilName);
            p.Write(hq,sizeof(hq));
            p.Write(animwater,sizeof(animwater));
            p.Write(hqanim,sizeof(hqanim));
         p.SaveToFile(terpath+'tmp\'+fns+'.sps',0,p.Position);
         p.Free;
         f.Section:=fns;
         f.ValueString('file',fns+'.pcx');
         if mapitems[f1].pass=1 then f.ValueString('water','1');
         if mapitems[f1].pass=2 then f.ValueString('coast','1');
         if mapitems[f1].SFinal.pureWater>=2 then f.ValueString('overlay','1');
         mapitems[f1].mmFileName:=fns;
      end;
   end;
   f.Free;
   f:=OpenIniFile(getstartdir+'max.ini');
   f.Mode:=ifmRead;
   f.Section:='max';
   mappath:=f.ValueString('maps','');
   f.Free;
   mappath:=getstartdir+mappath;
   mappath:=IncludeTrailingPathDelimiter(mappath);
   if not(directoryExists(mappath+'tmp'))then createdir(mappath+'tmp');
   DeleteFiles(mappath+'tmp\*.*');
   p:=NewMemoryStream;
   hdr:='[MMs M.A.X.-Map-File]';
   p.WriteStr(hdr);
   f1:=mapsize.x;
   p.Write(f1,4);
if useMMwaterOnly=255 then begin
   f1:=defaultwaterID;
   if f1=-1 then begin
      f1:=waterIDinCache;
      if f1=-1 then hdr:='water_blue'
               else hdr:=ExtractFileNameWOExt(Sfiles.Names[f1]);
      f1:=mapitemscount+1;
   end else hdr:=mapitems[f1].mmFileName;
   p.Write(f1,4);
   for f2:=0 to mapsize.x-1 do
      for f3:=0 to mapsize.y-1 do begin
         fn:=readymapdata[f2,f3];
         p.Write(fn,4);
      end;
   for f2:=0 to mapitemscount do begin
      fn:=f2;
      p.Write(fn,4);
      p.WriteStrZ(mapitems[f2].mmFileName);
   end;
   if f1>mapitemscount then begin
      f2:=mapitemscount+1;
      p.Write(f2,4);
      p.WriteStrZ(hdr);
   end;
end else begin
   f1:=useMMwaterOnly;hdr:='water_blue';
   if f1=1 then hdr:='water_lblue';
   if f1=2 then hdr:='water_brown';
   p.Write(f1,4);
   for f2:=0 to mapsize.x-1 do
      for f3:=0 to mapsize.y-1 do begin
         fn:=readymapdata[f2,f3];
         if mapitems[readymapdata[f2,f3]].sfinal.purewater=1 then fn:=f1 else inc(fn,100);
         p.Write(fn,4);
      end;
   for f2:=0 to mapitemscount do begin
      fn:=f2+100;
      if mapitems[f2].sfinal.purewater<>1 then begin
         p.Write(fn,4);
         p.WriteStrZ(mapitems[f2].mmFileName);
      end;
   end;
   begin
      p.Write(f1,4);
      p.WriteStrZ(hdr);
   end;
end;
   p.SaveToFile(mappath+'tmp\'+fname+'.map',0,p.Position);
   p.free;
   p:=newmemorystream;
   maxmap.SaveMinimapToStream(p);
   p.SaveToFile(mappath+'tmp\'+fname+'.bmp',0,p.Position);
   p.Free;
   copymovefiles(terpath+'tmp\*.*',terpath,true);
   copymovefiles(mappath+'tmp\*.*',mappath,true);
Windows.RemoveDirectory(PChar(terpath+'tmp'));

Windows.RemoveDirectory(PChar(mappath+'tmp'));

end;

initialization
mapgen:=nil;
rmax:=13333;setlength(rnddata,13334);
for rpos:=1 to rmax do rnddata[rpos]:=random(10000);
rpos:=1;
finalization
setlength(rnddata,0);
end.

